/*!
 * Application Insights JavaScript SDK - Channel, 3.3.7
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */
"use strict";var strShimFunction="function",strShimObject="object",strShimUndefined="undefined",strShimPrototype="prototype",ObjClass$1=Object,ObjProto$1=ObjClass$1[strShimPrototype];function _pureAssign(e,t){return e||t}function _pureRef(e,t){return e[t]}var UNDEF_VALUE=undefined,NULL_VALUE=null,EMPTY="",FUNCTION="function",OBJECT="object",PROTOTYPE="prototype",__PROTO__="__proto__",UNDEFINED="undefined",CONSTRUCTOR="constructor",SYMBOL="Symbol",LENGTH="length",NAME="name",CALL="call",TO_STRING="toString",GET_OWN_PROPERTY_DESCRIPTOR="getOwnPropertyDescriptor",ObjClass=_pureAssign(Object),ObjProto=_pureRef(ObjClass,PROTOTYPE),StrCls=_pureAssign(String),StrProto=_pureRef(StrCls,PROTOTYPE),MathCls=_pureAssign(Math),ArrCls=_pureAssign(Array),ArrProto=_pureRef(ArrCls,PROTOTYPE),ArrSlice=_pureRef(ArrProto,"slice"),POLYFILL_TAG="_polyfill",POLYFILL_TYPE_NAME="__nw21$polytype__";function safe(e,t){try{return{v:e.apply(this,t)}}catch(n){return{e:n}}}function safeGet(e,t,n){e=safe(e,n);return e.e?t:e.v}function _createIs(t){return function(e){return typeof e===t}}function _createObjIs(e){var t="[object "+e+"]";return function(e){return!(!e||objToString(e)!==t)}}function objToString(e){return ObjProto[TO_STRING].call(e)}function isUndefined(e){return typeof e===UNDEFINED||e===UNDEFINED}function isStrictUndefined(e){return e===UNDEF_VALUE}function isNullOrUndefined(e){return e===NULL_VALUE||isUndefined(e)}function isStrictNullOrUndefined(e){return e===NULL_VALUE||e===UNDEF_VALUE}function isDefined(e){return!!e||e!==UNDEF_VALUE}var isString=_createIs("string"),isFunction=_createIs(FUNCTION);function isObject(e){return!(!e&&isNullOrUndefined(e)||!e||typeof e!==OBJECT)}var isArray=_pureRef(ArrCls,"isArray"),isNumber=_createIs("number"),isBoolean=_createIs("boolean"),isError=_createObjIs("Error");function isPromiseLike(e){return!!(e&&e.then&&isFunction(e.then))}function isTruthy(e){return!(!e||safeGet(function(){return!(e&&0+e)},!e))}function _returnNothing(){}function _returnFalse(){return!1}var asString=_pureAssign(StrCls),ERROR_TYPE="[object Error]";function dumpObj(e,t){var n=EMPTY,r=ObjProto[TO_STRING][CALL](e);r===ERROR_TYPE&&(e={stack:asString(e.stack),message:asString(e.message),name:asString(e.name)});try{n=((n=JSON.stringify(e,NULL_VALUE,t?"number"==typeof t?t:4:UNDEF_VALUE))?n.replace(/"(\w+)"\s*:\s{0,1}/g,"$1: "):NULL_VALUE)||asString(e)}catch(o){n=" - "+dumpObj(o,t)}return r+": "+n}function throwTypeError(e){throw new TypeError(e)}function _throwIfNullOrUndefined(e){isStrictNullOrUndefined(e)&&throwTypeError("Cannot convert undefined or null to object")}function objHasOwnProperty(e,t){return!!e&&ObjProto.hasOwnProperty[CALL](e,t)}var _objGetOwnPropertyDescriptor$2=_pureAssign(_pureRef(ObjClass,GET_OWN_PROPERTY_DESCRIPTOR),_returnNothing),objHasOwn=_pureAssign(_pureRef(ObjClass,"hasOwn"),polyObjHasOwn);function polyObjHasOwn(e,t){return _throwIfNullOrUndefined(e),objHasOwnProperty(e,t)||!!_objGetOwnPropertyDescriptor$2(e,t)}function objForEachKey(e,t,n){if(e&&(isObject(e)||isFunction(e)))for(var r in e)if(objHasOwn(e,r)&&-1===t[CALL](n||e,r,e[r]))break}function arrForEach(e,t,n){if(e)for(var r=e[LENGTH]>>>0,o=0;o<r&&!(o in e&&-1===t[CALL](n||e,e[o],o,e));o++);}var _unwrapFunction=_unwrapFunctionWithPoly;function _unwrapFunctionWithPoly(r,e,o){var a=e?e[r]:NULL_VALUE;return function(e){var t,n=(e?e[r]:NULL_VALUE)||a;if(n||o)return t=arguments,(n||o).apply(e,n?ArrSlice[CALL](t,1):t);throwTypeError('"'+asString(r)+'" not defined for '+dumpObj(e))}}var _objGetOwnPropertyDescriptor$1=_pureAssign(_pureRef(ObjClass,GET_OWN_PROPERTY_DESCRIPTOR),_returnNothing),propMap={e:"enumerable",c:"configurable",v:"value",w:"writable",g:"get",s:"set"};function _createProp(t){var e,n={};return n[propMap.c]=!0,n[propMap.e]=!0,t.l&&(n.get=function(){return t.l.v},(e=_objGetOwnPropertyDescriptor$1(t.l,"v"))&&e.set&&(n.set=function(e){t.l.v=e})),objForEachKey(t,function(e,t){n[propMap[e]]=isStrictUndefined(t)?n[propMap[e]]:t}),n}var objDefineProp=_pureRef(ObjClass,"defineProperty"),objDefineProperties=_pureRef(ObjClass,"defineProperties");function objDefine(e,t,n){return objDefineProp(e,t,_createProp(n))}function _createKeyValueMap(e,n,r,t,o){var a={};return objForEachKey(e,function(e,t){_assignMapValue(a,e,n?t:e),_assignMapValue(a,t,r?t:e)}),t?t(a):a}function _assignMapValue(e,t,n,r){objDefineProp(e,t,{value:n,enumerable:!0,writable:!1})}var objIsFrozen=_pureAssign(_pureRef(ObjClass,"isFrozen"),_returnFalse),_objFreeze=_pureRef(ObjClass,"freeze");function _doNothing(e){return e}function _getProto(e){return _throwIfNullOrUndefined(e),e[__PROTO__]||NULL_VALUE}var objAssign=_pureRef(ObjClass,"assign"),objKeys=_pureRef(ObjClass,"keys");function _deepFreeze(e,n){if((isArray(e)||isObject(e)||isFunction(e))&&!objIsFrozen(e)){for(var t=0;t<n.length;t++)if(n[t]===e)return e;n.push(e),objForEachKey(e,function(e,t){_deepFreeze(t,n)}),objFreeze(e)}return e}function objDeepFreeze(e){return _objFreeze?_deepFreeze(e,[]):e}var objFreeze=_pureAssign(_objFreeze,_doNothing),objGetPrototypeOf=_pureAssign(_pureRef(ObjClass,"getPrototypeOf"),_getProto);function createEnum(e){return _createKeyValueMap(e,1,0,objFreeze)}function createEnumKeyMap(e){return _createKeyValueMap(e,0,0,objFreeze)}function createSimpleMap(e){var n={};return objForEachKey(e,function(e,t){_assignMapValue(n,e,t[1]),_assignMapValue(n,t[0],t[1])}),objFreeze(n)}function createTypeMap(e){return createSimpleMap(e)}var _globalCfg,_wellKnownSymbolMap=createEnumKeyMap({asyncIterator:0,hasInstance:1,isConcatSpreadable:2,iterator:3,match:4,matchAll:5,replace:6,search:7,species:8,split:9,toPrimitive:10,toStringTag:11,unscopables:12}),GLOBAL_CONFIG_KEY="__tsUtils$gblCfg";function _getGlobalValue(){var e;return(e=(e=(e=typeof globalThis!==UNDEFINED?globalThis:e)||typeof self===UNDEFINED?e:self)||typeof window===UNDEFINED?e:window)||typeof global===UNDEFINED?e:global}function _getGlobalConfig(){var e;return _globalCfg||(e=safe(_getGlobalValue).v||{},_globalCfg=e[GLOBAL_CONFIG_KEY]=e[GLOBAL_CONFIG_KEY]||{}),_globalCfg}var mathMin=_pureRef(MathCls,"min"),mathMax=_pureRef(MathCls,"max"),strSlice=_unwrapFunctionWithPoly("slice",StrProto),strSubstring=_unwrapFunctionWithPoly("substring",StrProto),strSubstr=_unwrapFunctionWithPoly("substr",StrProto,polyStrSubstr);function polyStrSubstr(e,t,n){return _throwIfNullOrUndefined(e),n<0?EMPTY:((t=t||0)<0&&(t=mathMax(t+e[LENGTH],0)),isUndefined(n)?strSlice(e,t):strSlice(e,t,t+n))}function _tagAsPolyfill(e,t){return e&&(safe(function(){e[POLYFILL_TAG]=!0,e[POLYFILL_TYPE_NAME]=t}),safe(objDefine,[e,POLYFILL_TAG,{v:!0,w:!1,e:!1}]),safe(objDefine,[e,POLYFILL_TYPE_NAME,{v:t,w:!1,e:!1}])),e}var _globalLazyTestHooks,objCreate=_pureAssign(_pureRef(ObjClass,"create"),polyObjCreate);function polyObjCreate(e,t){var n;function r(){}return n=isStrictNullOrUndefined(e)?{}:((n=typeof e)!==OBJECT&&n!==FUNCTION&&throwTypeError("Prototype must be an Object or function: "+dumpObj(e)),r[PROTOTYPE]=e,safe(function(){r[__PROTO__]=e}),new r),t&&safe(objDefineProperties,[n,t]),n}function utcNow(){return(Date.now||polyUtcNow)()}function polyUtcNow(){return(new Date).getTime()}function fnApply(e,t,n){return e.apply(t,n)}function _initTestHooks(){_globalLazyTestHooks=_getGlobalConfig()}function getLazy(t,n){var r={};return _globalLazyTestHooks||_initTestHooks(),r.b=_globalLazyTestHooks.lzy,objDefineProp(r,"v",{configurable:!0,get:function(){var e=fnApply(t,null,n);return _globalLazyTestHooks.lzy||objDefineProp(r,"v",{value:e}),r.b=_globalLazyTestHooks.lzy,e}}),r}var _polySymbols,_wellKnownSymbolCache,mathRandom=_pureRef(MathCls,"random"),_uniqueInstanceId=getLazy(function(){for(var e=utcNow().toString(36).slice(2);e.length<16;)e+=mathRandom().toString(36).slice(2);return e.substring(0,16)}),UNIQUE_REGISTRY_ID="_urid",POLY_SYM="$nw21sym",_polyId=0;function _globalSymbolRegistry(){var e;return _polySymbols||(e=_getGlobalConfig(),_polySymbols=e.gblSym=e.gblSym||{k:{},s:{}}),_polySymbols}function polyNewSymbol(e){var t="_"+_polyId+++"_"+_uniqueInstanceId.v,n=SYMBOL+"("+e+")";function r(e,t){objDefine(o,e,{v:t,e:!1,w:!1})}var o=objCreate(null);return r("description",asString(e)),r(TO_STRING,function(){return n+POLY_SYM+t}),r("valueOf",function(){return o}),r("v",n),r("_uid",t),_tagAsPolyfill(o,"symbol")}function polySymbolFor(e){var t,n,r=_globalSymbolRegistry();return objHasOwn(r.k,e)||(t=polyNewSymbol(e),n=objKeys(r.s).length,t[UNIQUE_REGISTRY_ID]=function(){return n+"_"+t[TO_STRING]()},r.k[e]=t,r.s[t[UNIQUE_REGISTRY_ID]()]=asString(e)),r.k[e]}function polyGetKnownSymbol(e){_wellKnownSymbolCache=_wellKnownSymbolCache||{};e=_wellKnownSymbolMap[e];return e?_wellKnownSymbolCache[e]=_wellKnownSymbolCache[e]||polyNewSymbol(SYMBOL+"."+e):void 0}function createCachedValue(e){return objDefineProp({toJSON:function(){return e}},"v",{value:e})}var _cachedGlobal,WINDOW="window";function _getGlobalInstFn(e,t){var n;return function(){return _globalLazyTestHooks||_initTestHooks(),(n=n&&!_globalLazyTestHooks.lzy?n:createCachedValue(safe(e,t).v)).v}}function getGlobal(e){return _globalLazyTestHooks||_initTestHooks(),(_cachedGlobal=_cachedGlobal&&!1!==e&&!_globalLazyTestHooks.lzy?_cachedGlobal:createCachedValue(safe(_getGlobalValue).v||NULL_VALUE)).v}function getInst(e,t){t=_cachedGlobal&&!1!==t?_cachedGlobal.v:getGlobal(t);if(t&&t[e])return t[e];if(e===WINDOW)try{return window}catch(n){}return NULL_VALUE}var getDocument=_getGlobalInstFn(getInst,["document"]);function hasWindow(){return!!getWindow()}var getWindow=_getGlobalInstFn(getInst,[WINDOW]);function hasNavigator(){return!!getNavigator()}var _symbol,_symbolFor,_iterSymbol$1,getNavigator=_getGlobalInstFn(getInst,["navigator"]),isNode=_getGlobalInstFn(function(){return!!safe(function(){return process&&(process.versions||{}).node}).v});function _initSymbol(){return _symbol=createCachedValue(safe(getInst,[SYMBOL]).v)}function _getSymbolKey(e){var t=(_globalLazyTestHooks.lzy?0:_symbol)||_initSymbol();return t.v?t.v[e]:UNDEF_VALUE}function hasSymbol(){return!!getSymbol()}function getSymbol(){return _globalLazyTestHooks||_initTestHooks(),((_globalLazyTestHooks.lzy?0:_symbol)||_initSymbol()).v}function getKnownSymbol(e,t){var n=_wellKnownSymbolMap[e],r=(_globalLazyTestHooks||_initTestHooks(),(_globalLazyTestHooks.lzy?0:_symbol)||_initSymbol());return r.v?r.v[n||e]:t?UNDEF_VALUE:polyGetKnownSymbol(e)}function newSymbol(e,t){_globalLazyTestHooks||_initTestHooks();var n=(_globalLazyTestHooks.lzy?0:_symbol)||_initSymbol();return n.v?n.v(e):t?NULL_VALUE:polyNewSymbol(e)}function symbolFor(e){return _globalLazyTestHooks||_initTestHooks(),((_symbolFor=(_globalLazyTestHooks.lzy?0:_symbolFor)||createCachedValue(safe(_getSymbolKey,["for"]).v)).v||polySymbolFor)(e)}function isIterator(e){return!!e&&isFunction(e.next)}function isIterable(e){return!isStrictNullOrUndefined(e)&&isFunction(e[getKnownSymbol(3)])}function iterForOf(e,t,n){if(e&&(isIterator(e)||(e=e[(_iterSymbol$1=_iterSymbol$1||createCachedValue(getKnownSymbol(3))).v]?e[_iterSymbol$1.v]():NULL_VALUE),isIterator(e))){var r=UNDEF_VALUE,o=UNDEF_VALUE;try{for(var a=0;!(o=e.next()).done&&-1!==t[CALL](n||e,o.value,a,e);)a++}catch(i){r={e:i},e["throw"]&&(o=NULL_VALUE,e["throw"](r))}finally{try{o&&!o.done&&e["return"]&&e["return"](o)}finally{if(r)throw r.e}}}}function arrAppend(t,e){return!isUndefined(e)&&t&&(isArray(e)?fnApply(t.push,t,e):isIterator(e)||isIterable(e)?iterForOf(e,function(e){t.push(e)}):t.push(e)),t}var _isProtoArray,arrIndexOf=_unwrapFunctionWithPoly("indexOf",ArrProto),arrMap=_unwrapFunctionWithPoly("map",ArrProto);function arrSlice(e,t,n){return((e?e.slice:NULL_VALUE)||ArrSlice).apply(e,ArrSlice[CALL](arguments,1))}var objSetPrototypeOf=_pureAssign(_pureRef(ObjClass,"setPrototypeOf"),_polyObjSetPrototypeOf);function _polyObjSetPrototypeOf(n,e){var t;return(_isProtoArray=_isProtoArray||createCachedValue(((t={})[__PROTO__]=[],t instanceof Array))).v?n[__PROTO__]=e:objForEachKey(e,function(e,t){return n[e]=t}),n}function _createCustomError(e,t,n){function r(){this[CONSTRUCTOR]=t,safe(objDefine,[this,NAME,{v:e,c:!0,e:!1}])}return safe(objDefine,[t,NAME,{v:e,c:!0,e:!1}]),(t=objSetPrototypeOf(t,n))[PROTOTYPE]=n===NULL_VALUE?objCreate(n):(r[PROTOTYPE]=n[PROTOTYPE],new r),t}function _setName(e,t){t&&(e[NAME]=t)}function createCustomError(o,a,e){var i=e||Error,_=i[PROTOTYPE][NAME],s=Error.captureStackTrace;return _createCustomError(o,function(){var e=this,t=arguments;try{safe(_setName,[i,o]);var n,r=fnApply(i,e,ArrSlice[CALL](t))||e;return r!==e&&(n=objGetPrototypeOf(e))!==objGetPrototypeOf(r)&&objSetPrototypeOf(r,n),s&&s(r,e[CONSTRUCTOR]),a&&a(r,t),r}finally{safe(_setName,[i,_])}},i)}function _createTrimFn(t){return function(e){return _throwIfNullOrUndefined(e),e&&e.replace?e.replace(t,EMPTY):e}}var _fnToString,_objCtrFnString,_gblWindow,polyStrTrim=_createTrimFn(/^\s+|(?=\s)\s+$/g),strTrim=_unwrapFunctionWithPoly("trim",StrProto,polyStrTrim),mathFloor=_pureRef(MathCls,"floor");function isPlainObject(e){if(!e||typeof e!==OBJECT)return!1;var t=!1;if(e!==(_gblWindow=_gblWindow||!hasWindow()||getWindow())){_objCtrFnString||(_fnToString=Function[PROTOTYPE][TO_STRING],_objCtrFnString=_fnToString[CALL](ObjClass));try{var n=objGetPrototypeOf(e),t=(t=!n)||!(!(n=objHasOwnProperty(n,CONSTRUCTOR)?n[CONSTRUCTOR]:n)||typeof n!==FUNCTION||_fnToString[CALL](n)!==_objCtrFnString)}catch(r){}}return t}var _setTimeoutFn,_clearTimeoutFn,mathRound=_pureRef(MathCls,"round"),objGetOwnPropertyDescriptor=_pureAssign(_pureRef(ObjClass,GET_OWN_PROPERTY_DESCRIPTOR),_returnNothing),strIndexOf=_unwrapFunctionWithPoly("indexOf",StrProto),REF="ref",UNREF="unref",HAS_REF="hasRef",ENABLED="enabled";function _createTimerHandler(e,t,n){var r,o=!0,a=e?t(NULL_VALUE):NULL_VALUE;function i(){return o=!1,a&&a[UNREF]&&a[UNREF](),r}function _(){a&&n(a),a=NULL_VALUE}function s(){return a=t(a),o||i(),r}return(r={cancel:_,refresh:s})[HAS_REF]=function(){return a&&a[HAS_REF]?a[HAS_REF]():o},r[REF]=function(){return o=!0,a&&a[REF]&&a[REF](),r},r[UNREF]=i,{h:r=objDefineProp(r,ENABLED,{get:function(){return!!a},set:function(e){!e&&a&&_(),e&&!a&&s()}}),dn:function(){a=NULL_VALUE}}}function _resolveTimeoutFn(e){var t,e=isFunction(e)?e:_setTimeoutFn;return e||(t=_getGlobalConfig().tmOut||[],isArray(t)&&0<t.length&&isFunction(t[0])&&(e=t[0])),e||setTimeout}function _resolveClearTimeoutFn(e){var t,e=isFunction(e)?e:_clearTimeoutFn;return e||(t=_getGlobalConfig().tmOut||[],isArray(t)&&1<t.length&&isFunction(t[1])&&(e=t[1])),e||clearTimeout}function _createTimeoutWith(e,t,n){var r=isArray(t),o=r?t.length:0,a=_resolveTimeoutFn(0<o?t[0]:r?UNDEF_VALUE:t),i=_resolveClearTimeoutFn(1<o?t[1]:UNDEF_VALUE),_=n[0],s=(n[0]=function(){s.dn(),fnApply(_,UNDEF_VALUE,ArrSlice[CALL](arguments))},_createTimerHandler(e,function(e){if(e){if(e.refresh)return e.refresh(),e;fnApply(i,UNDEF_VALUE,[e])}return fnApply(a,UNDEF_VALUE,n)},function(e){fnApply(i,UNDEF_VALUE,[e])}));return s.h}function scheduleTimeout(e,t){return _createTimeoutWith(!0,UNDEF_VALUE,ArrSlice[CALL](arguments))}(getGlobal()||{}).Symbol,(getGlobal()||{}).Reflect;var _a$3,strHasOwnProperty="hasOwnProperty",__objAssignFnImpl=function(e){for(var t,n=1,r=arguments.length;n<r;n++)for(var o in t=arguments[n])ObjProto$1[strHasOwnProperty].call(t,o)&&(e[o]=t[o]);return e},__assignFn=objAssign||__objAssignFnImpl,extendStaticsFn=function(e,t){return(extendStaticsFn=ObjClass$1.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t[strHasOwnProperty](n)&&(e[n]=t[n])})(e,t)};function __extendsFn(e,t){function n(){this.constructor=e}typeof t!==strShimFunction&&null!==t&&throwTypeError("Class extends value "+t+" is not a constructor or null"),extendStaticsFn(e,t),e[strShimPrototype]=null===t?objCreate(t):(n[strShimPrototype]=t[strShimPrototype],new n)}var Constructor="constructor",Prototype="prototype",strFunction="function",DynInstFuncTable="_dynInstFuncs",DynProxyTag="_isDynProxy",DynClassName="_dynClass",DynClassNamePrefix="_dynCls$",DynInstChkTag="_dynInstChk",DynAllowInstChkTag=DynInstChkTag,DynProtoDefaultOptions="_dfOpts",UnknownValue="_unknown_",str__Proto="__proto__",DynProtoBaseProto="_dyn"+str__Proto,DynProtoGlobalSettings="__dynProto$Gbl",DynProtoCurrent="_dynInstProto",strUseBaseInst="useBaseInst",strSetInstFuncs="setInstFuncs",Obj=Object,_objGetPrototypeOf=Obj.getPrototypeOf,_objGetOwnProps=Obj.getOwnPropertyNames,_gbl=getGlobal(),_gblInst=_gbl[DynProtoGlobalSettings]||(_gbl[DynProtoGlobalSettings]={o:((_a$3={})[strSetInstFuncs]=!0,_a$3[strUseBaseInst]=!0,_a$3),n:1e3});function _isObjectOrArrayPrototype(e){return e&&(e===Obj[Prototype]||e===Array[Prototype])}function _isObjectArrayOrFunctionPrototype(e){return _isObjectOrArrayPrototype(e)||e===Function[Prototype]}function _getObjProto(e){if(e){if(_objGetPrototypeOf)return _objGetPrototypeOf(e);var t=e[str__Proto]||e[Prototype]||(e[Constructor]?e[Constructor][Prototype]:null),n=e[DynProtoBaseProto]||t;objHasOwnProperty(e,DynProtoBaseProto)||(delete e[DynProtoCurrent],n=e[DynProtoBaseProto]=e[DynProtoCurrent]||e[DynProtoBaseProto],e[DynProtoCurrent]=t)}return n}function _forEachProp(e,t){var n=[];if(_objGetOwnProps)n=_objGetOwnProps(e);else for(var r in e)"string"==typeof r&&objHasOwnProperty(e,r)&&n.push(r);if(n&&0<n.length)for(var o=0;o<n.length;o++)t(n[o])}function _isDynamicCandidate(e,t,n){return t!==Constructor&&typeof e[t]===strFunction&&(n||objHasOwnProperty(e,t))&&t!==str__Proto&&t!==Prototype}function _throwTypeError(e){throwTypeError("DynamicProto: "+e)}function _getInstanceFuncs(t){var n=objCreate(null);return _forEachProp(t,function(e){!n[e]&&_isDynamicCandidate(t,e,!1)&&(n[e]=t[e])}),n}function _hasVisited(e,t){for(var n=e.length-1;0<=n;n--)if(e[n]===t)return!0;return!1}function _getBaseFuncs(e,t,n,a){function r(e,t,n){var r,o=t[n];return o[DynProxyTag]&&a&&!1!==(r=e[DynInstFuncTable]||{})[DynAllowInstChkTag]&&(o=(r[t[DynClassName]]||{})[n]||o),function(){return o.apply(e,arguments)}}for(var o=objCreate(null),i=(_forEachProp(n,function(e){o[e]=r(t,n,e)}),_getObjProto(e)),_=[];i&&!_isObjectArrayOrFunctionPrototype(i)&&!_hasVisited(_,i);)_forEachProp(i,function(e){!o[e]&&_isDynamicCandidate(i,e,!_objGetPrototypeOf)&&(o[e]=r(t,i,e))}),_.push(i),i=_getObjProto(i);return o}function _getInstFunc(e,t,n,r){var o=null;if(e&&objHasOwnProperty(n,DynClassName)){var a=e[DynInstFuncTable]||objCreate(null);if((o=(a[n[DynClassName]]||objCreate(null))[t])||_throwTypeError("Missing ["+t+"] "+strFunction),!o[DynInstChkTag]&&!1!==a[DynAllowInstChkTag]){for(var i=!objHasOwnProperty(e,t),_=_getObjProto(e),s=[];i&&_&&!_isObjectArrayOrFunctionPrototype(_)&&!_hasVisited(s,_);){var c=_[t];if(c){i=c===r;break}s.push(_),_=_getObjProto(_)}try{i&&(e[t]=o),o[DynInstChkTag]=1}catch(u){a[DynAllowInstChkTag]=!1}}}return o}function _getProtoFunc(e,t,n){var r=t[e];return typeof(r=r===n?_getObjProto(t)[e]:r)!==strFunction&&_throwTypeError("["+e+"] is not a "+strFunction),r}function _populatePrototype(o,e,a,i,t){var n,_;_isObjectOrArrayPrototype(o)||_isObjectOrArrayPrototype(n=a[DynInstFuncTable]=a[DynInstFuncTable]||objCreate(null))||(_=n[e]=n[e]||objCreate(null),!1!==n[DynAllowInstChkTag]&&(n[DynAllowInstChkTag]=!!t),_isObjectOrArrayPrototype(_)||_forEachProp(a,function(e){var t,n,r;_isDynamicCandidate(a,e,!1)&&a[e]!==i[e]&&(_[e]=a[e],delete a[e],objHasOwnProperty(o,e)&&(!o[e]||o[e][DynProxyTag])||(o[e]=(t=o,n=e,(r=function(){return(_getInstFunc(this,n,t,r)||_getProtoFunc(n,t,r)).apply(this,arguments)})[DynProxyTag]=1,r)))}))}function _checkPrototype(e,t){if(_objGetPrototypeOf){for(var n=[],r=_getObjProto(t);r&&!_isObjectArrayOrFunctionPrototype(r)&&!_hasVisited(n,r);){if(r===e)return!0;n.push(r),r=_getObjProto(r)}return!1}return!0}function _getObjName(e,t){return objHasOwnProperty(e,Prototype)?e.name||t||UnknownValue:((e||{})[Constructor]||{}).name||t||UnknownValue}function dynamicProto(e,t,n,r){objHasOwnProperty(e,Prototype)||_throwTypeError("theClass is an invalid class definition.");var o=e[Prototype],a=(_checkPrototype(o,t)||_throwTypeError("["+_getObjName(e)+"] not in hierarchy of ["+_getObjName(t)+"]"),null),e=(objHasOwnProperty(o,DynClassName)?a=o[DynClassName]:(a=DynClassNamePrefix+_getObjName(e,"_")+"$"+_gblInst.n,_gblInst.n++,o[DynClassName]=a),dynamicProto[DynProtoDefaultOptions]),i=!!e[strUseBaseInst],_=(i&&r&&r[strUseBaseInst]!==undefined&&(i=!!r[strUseBaseInst]),_getInstanceFuncs(t)),i=(n(t,_getBaseFuncs(o,t,_,i)),!!_objGetPrototypeOf&&!!e[strSetInstFuncs]);_populatePrototype(o,a,t,_,!1!==(i=i&&r?!!r[strSetInstFuncs]:i))}dynamicProto[DynProtoDefaultOptions]=_gblInst.o;var aggregationErrorType,createEnumStyle=createEnum,createValueMap=createTypeMap,ActiveStatus=createEnumStyle({NONE:0,PENDING:3,INACTIVE:1,ACTIVE:2}),_DYN_TO_LOWER_CASE$1="toLowerCase",_DYN_LENGTH$2="length",_DYN_WARN_TO_CONSOLE="warnToConsole",_DYN_THROW_INTERNAL="throwInternal",_DYN_WATCH="watch",_DYN_APPLY="apply",_DYN_PUSH$1="push",_DYN_SPLICE="splice",_DYN_LOGGER="logger",_DYN_CANCEL="cancel",_DYN_INITIALIZE$1="initialize",_DYN_IDENTIFIER="identifier",_DYN_IS_INITIALIZED="isInitialized",_DYN_GET_PLUGIN="getPlugin",_DYN_NAME$2="name",_DYN_PROCESS_NEXT="processNext",_DYN_GET_PROCESS_TEL_CONT2="getProcessTelContext",_DYN_VALUE="value",_DYN_UNLOAD="unload",_DYN_LOGGING_LEVEL_CONSOL4="loggingLevelConsole",_DYN_CREATE_NEW="createNew",_DYN_TEARDOWN="teardown",_DYN_MESSAGE_ID="messageId",_DYN_MESSAGE$1="message",_DYN_DIAG_LOG$1="diagLog",_DYN__DO_TEARDOWN="_doTeardown",_DYN_UPDATE="update",_DYN_GET_NEXT="getNext",_DYN_SET_NEXT_PLUGIN="setNextPlugin",_DYN_USER_AGENT="userAgent",_DYN_SPLIT$1="split",_DYN_REPLACE="replace",_DYN_TYPE="type",_DYN_EVT_NAME="evtName",_DYN_STATUS="status",_DYN_INDEX_OF="indexOf",_DYN_GET_ALL_RESPONSE_HEA5="getAllResponseHeaders",_DYN_IS_CHILD_EVT="isChildEvt",_DYN_DATA$1="data",_DYN_GET_CTX="getCtx",_DYN_SET_CTX="setCtx",_DYN_ITEMS_RECEIVED$1="itemsReceived",_DYN_HEADERS="headers",_DYN_URL_STRING="urlString",_DYN_TIMEOUT="timeout";function throwAggregationError(e,t){aggregationErrorType=aggregationErrorType||createCustomError("AggregationError",function(e,t){1<t[_DYN_LENGTH$2]&&(e.errors=t[1])});var n=e||"One or more errors occurred.";throw arrForEach(t,function(e,t){n+="\n".concat(t," > ").concat(dumpObj(e))}),new aggregationErrorType(n,t||[])}var STR_PROMISE="Promise",REJECTED="rejected";function doAwaitResponse(e,t){return doAwait(e,function(e){return t?t({status:"fulfilled",rejected:!1,value:e}):e},function(e){return t?t({status:REJECTED,rejected:!0,reason:e}):e})}function doAwait(e,t,n,r){var o=e;try{if(isPromiseLike(e))(t||n)&&(o=e.then(t,n));else try{t&&(o=t(e))}catch(a){if(!n)throw a;o=n(a)}}finally{r&&doFinally(o,r)}return o}function doFinally(e,t){var n=e;return t&&(isPromiseLike(e)?n=e["finally"]?e["finally"](t):e.then(function(e){return t(),e},function(e){throw t(),e}):t()),n}var _hasInitEvent,STRING_STATES=["pending","resolving","resolved",REJECTED],DISPATCH_EVENT="dispatchEvent";function _hasInitEventFn(e){var t;return!!(t=e&&e.createEvent?e.createEvent("Event"):t)&&t.initEvent}function emitEvent(e,t,n,r){var o=getDocument(),o=(_hasInitEvent=_hasInitEvent||createCachedValue(!!safe(_hasInitEventFn,[o]).v)).v?o.createEvent("Event"):r?new Event(t):{};n&&n(o),_hasInitEvent.v&&o.initEvent(t,!1,!0),o&&e[DISPATCH_EVENT]?e[DISPATCH_EVENT](o):(r=e["on"+t])?r(o):(n=getInst("console"))&&(n.error||n.log)(t,dumpObj(o))}var _hasPromiseRejectionEvent,_promiseCls,_promiseCreator,NODE_UNHANDLED_REJECTION="unhandledRejection",UNHANDLED_REJECTION=NODE_UNHANDLED_REJECTION.toLowerCase(),_unhandledRejectionTimeout=10;function dumpFnObj(e){return isFunction(e)?e.toString():dumpObj(e)}function _createPromise(e,t,n){var _,r,o=arrSlice(arguments,3),s=0,c=!1,u=[],l=!1,N=null;function a(a,i){return l=!0,N&&N.cancel(),N=null,e(function(r,o){u.push(function(){try{var e=2===s?a:i,t=isUndefined(e)?_:isFunction(e)?e(_):e;isPromiseLike(t)?t.then(r,o):(e||3!==s?r:o)(t)}catch(n){o(n)}}),c&&E()},o)}function i(){return STRING_STATES[s]}function E(){var e;0<u.length&&(e=u.slice(),u=[],l=!0,N&&N.cancel(),N=null,t(e))}function f(t,n){return function(e){if(s===n){if(2===t&&isPromiseLike(e))return s=1,void e.then(f(2,1),f(3,1));s=t,c=!0,_=e,E(),l||3!==t||N||(N=scheduleTimeout(D,_unhandledRejectionTimeout))}}}function D(){var e;l||(l=!0,isNode()?process.emit(NODE_UNHANDLED_REJECTION,_,r):(e=getWindow()||getGlobal(),_hasPromiseRejectionEvent=_hasPromiseRejectionEvent||createCachedValue(safe(getInst,[STR_PROMISE+"RejectionEvent"]).v),emitEvent(e,UNHANDLED_REJECTION,function(e){return objDefine(e,"promise",{g:function(){return r}}),e.reason=_,e},!!_hasPromiseRejectionEvent.v)))}objDefineProp(r={then:a,"catch":function(e){return a(undefined,e)},"finally":function(t){var e=t,n=t;return isFunction(t)&&(e=function(e){return t&&t(),e},n=function(e){throw t&&t(),e}),a(e,n)}},"state",{get:i}),hasSymbol()&&(r[getKnownSymbol(11)]="IPromise"),r.toString=function(){return"IPromise "+i()+(c?" - "+dumpFnObj(_):"")},isFunction(n)||throwTypeError(STR_PROMISE+": executor is not a function - "+dumpFnObj(n));var d=f(3,0);try{n.call(r,f(2,0),d)}catch(T){d(T)}return r}function syncItemProcessor(e){arrForEach(e,function(e){try{e()}catch(t){}})}function timeoutItemProcessor(e){var t=isNumber(e)?e:0;return function(e){scheduleTimeout(function(){syncItemProcessor(e)},t)}}function createAsyncPromise(e,t){return _createPromise(createAsyncPromise,timeoutItemProcessor(t),e,t)}function createNativePromise(e,t){var n=(_promiseCls=_promiseCls||createCachedValue(safe(getInst,[STR_PROMISE]).v||null)).v;if(!n)return createAsyncPromise(e);isFunction(e)||throwTypeError(STR_PROMISE+": executor is not a function - "+dumpObj(e));var r=0,n=new n(function(t,n){e(function(e){r=2,t(e)},function(e){r=3,n(e)})});return objDefineProp(n,"state",{get:function(){return STRING_STATES[r]}}),n}function createPromise(e,t){return(_promiseCreator=_promiseCreator||createCachedValue(createNativePromise)).v.call(this,e,t)}var UNDEFINED_VALUE$1=undefined,STR_EMPTY$1="",STR_CORE="core",STR_DISABLED="disabled",STR_EXTENSION_CONFIG="extensionConfig",STR_PROCESS_TELEMETRY="processTelemetry",STR_PRIORITY="priority",STR_GET_PERF_MGR="getPerfMgr",STR_NOT_DYNAMIC_ERROR="Not dynamic - ",rCamelCase=/-([a-z])/g,rNormalizeInvalid=/([^\w\d_$])/g,rLeadingNumeric=/^(\d+[\w\d_$])/;function isNotNullOrUndefined(e){return!isNullOrUndefined(e)}function normalizeJsName(e){return e&&isString(e)?(e=(e=e[_DYN_REPLACE](rCamelCase,function(e,t){return t.toUpperCase()}))[_DYN_REPLACE](rNormalizeInvalid,"_"))[_DYN_REPLACE](rLeadingNumeric,function(e,t){return"_"+t}):e}function strContains(e,t){return!(!e||!t)&&-1!==strIndexOf(e,t)}function toISOString(e){return e&&e.toISOString()||""}function getExceptionName(e){return isError(e)?e[_DYN_NAME$2]:STR_EMPTY$1}function setValue(e,t,n,r,o){var a=n;return!e||(a=e[t])===n||o&&!o(a)||r&&!r(n)||(e[t]=a=n),a}function _createProxyFunction(e,t){var n=null,r=null;return isFunction(e)?n=e:r=e,function(){var e=arguments;if(r=n?n():r)return r[t][_DYN_APPLY](r,e)}}function proxyFunctionAs(e,t,n,r,o){e&&t&&n&&(!1===o&&!isUndefined(e[t])||(e[t]=_createProxyFunction(n,r)))}function createClassFromInterface(e){return function(){var n=this;e&&objForEachKey(e,function(e,t){n[e]=t})}}function optimizeObject(e){return e&&objAssign?ObjClass$1(objAssign({},e)):e}function objExtend(e,t,n,r,o,a){var i=arguments,_=i[0]||{},s=i[_DYN_LENGTH$2],c=!1,u=1;for(0<s&&isBoolean(_)&&(c=_,_=i[u]||{},u++),isObject(_)||(_={});u<s;u++){var l,N,E,f,D=i[u],d=isArray(D),T=isObject(D);for(l in D)(d&&l in D||T&&objHasOwn(D,l))&&(N=D[l],E=void 0,c&&N&&((E=isArray(N))||isPlainObject(N))&&(f=_[l],E?isArray(f)||(f=[]):isPlainObject(f)||(f={}),N=objExtend(c,f,N)),N!==undefined&&(_[l]=N))}return _}function isFeatureEnabled(e,t,n){t=t&&t.featureOptIn&&t.featureOptIn[e];if(e&&t){e=t.mode;if(3===e)return!0;if(2===e)return!1}return n}function getResponseText(e){try{return e.responseText}catch(t){}return null}function formatErrorMessageXdr(e,t){return e?"XDomainRequest,Response:"+getResponseText(e)||"":t}function formatErrorMessageXhr(e,t){return e?"XMLHttpRequest,Status:"+e[_DYN_STATUS]+",Response:"+getResponseText(e)||e.response||"":t}function prependTransports(e,t){return t&&(isNumber(t)?e=[t].concat(e):isArray(t)&&(e=t.concat(e))),e}var strDisabledPropertyName="Microsoft_ApplicationInsights_BypassAjaxInstrumentation",strWithCredentials="withCredentials",strTimeout="timeout";function openXhr(e,t,n,r,o,a){function i(e,t,n){try{e[t]=n}catch(r){}}void 0===r&&(r=!1),void 0===o&&(o=!1);var _=new XMLHttpRequest;return r&&i(_,strDisabledPropertyName,r),n&&i(_,strWithCredentials,n),_.open(e,t,!o),n&&i(_,strWithCredentials,n),!o&&a&&i(_,strTimeout,a),_}function convertAllHeadersToMap(e){var r={};return isString(e)&&arrForEach(strTrim(e)[_DYN_SPLIT$1](/[\r\n]+/),function(e){var t,n;e&&(-1!==(n=e[_DYN_INDEX_OF](": "))?(t=strTrim(e.substring(0,n))[_DYN_TO_LOWER_CASE$1](),n=strTrim(e.substring(n+1)),r[t]=n):r[strTrim(e)]=1)}),r}function _appendHeader(e,t,n){return!e[n]&&t&&t.getResponseHeader&&(t=t.getResponseHeader(n))&&(e[n]=strTrim(t)),e}var STR_KILL_DURATION_HEADER="kill-duration",STR_KILL_DURATION_SECONDS_HEADER="kill-duration-seconds",STR_TIME_DELTA_HEADER="time-delta-millis";function _getAllResponseHeaders(e,t){var n={};return e[_DYN_GET_ALL_RESPONSE_HEA5]?n=convertAllHeadersToMap(e[_DYN_GET_ALL_RESPONSE_HEA5]()):t&&(n=_appendHeader(n,e,STR_TIME_DELTA_HEADER),n=_appendHeader(n,e,STR_KILL_DURATION_HEADER),n=_appendHeader(n,e,STR_KILL_DURATION_SECONDS_HEADER)),n}var strDocumentMode="documentMode",strLocation="location",strConsole="console",strJSON="JSON",strCrypto="crypto",strMsCrypto="msCrypto",strMsie="msie",strTrident="trident/",strXMLHttpRequest="XMLHttpRequest",_isTrident=null,_navUserAgentCheck=null,_enableMocks=!1,_useXDomainRequest=null,_beaconsSupported=null;function _hasProperty(e,t){var n,r=!1;if(e){try{(r=t in e)||(n=e[strShimPrototype])&&(r=t in n)}catch(o){}if(!r)try{r=!isUndefined((new e)[t])}catch(o){}}return r}function getLocation(e){if(e&&_enableMocks){e=getInst("__mockLocation");if(e)return e}return typeof location===strShimObject&&location?location:getInst(strLocation)}function getConsole(){return typeof console!==strShimUndefined?console:getInst(strConsole)}function hasJSON(){return!!(typeof JSON===strShimObject&&JSON||null!==getInst(strJSON))}function getJSON(){return hasJSON()?JSON||getInst(strJSON):null}function getCrypto(){return getInst(strCrypto)}function getMsCrypto(){return getInst(strMsCrypto)}function isIE(){var e=getNavigator();return!e||e[_DYN_USER_AGENT]===_navUserAgentCheck&&null!==_isTrident||(e=((_navUserAgentCheck=e[_DYN_USER_AGENT])||STR_EMPTY$1)[_DYN_TO_LOWER_CASE$1](),_isTrident=strContains(e,strMsie)||strContains(e,strTrident)),_isTrident}function getIEVersion(e){var t=((e=(e=void 0===e?null:e)?e:(t=getNavigator()||{})?(t.userAgent||STR_EMPTY$1)[_DYN_TO_LOWER_CASE$1]():STR_EMPTY$1)||STR_EMPTY$1)[_DYN_TO_LOWER_CASE$1]();if(strContains(t,strMsie))return e=getDocument()||{},mathMax(parseInt(t[_DYN_SPLIT$1](strMsie)[1]),e[strDocumentMode]||0);if(strContains(t,strTrident)){e=parseInt(t[_DYN_SPLIT$1](strTrident)[1]);if(e)return e+4}return null}function isBeaconsSupported(e){return _beaconsSupported=null!==_beaconsSupported&&!1!==e?_beaconsSupported:hasNavigator()&&!!getNavigator().sendBeacon}function isFetchSupported(e){var t=!1;try{var t=!!getInst("fetch"),n=getInst("Request");t&&e&&n&&(t=_hasProperty(n,"keepalive"))}catch(r){}return t}function useXDomainRequest(){return _useXDomainRequest=null===_useXDomainRequest&&(_useXDomainRequest=typeof XDomainRequest!==strShimUndefined)&&isXhrSupported()?_useXDomainRequest&&!_hasProperty(getInst(strXMLHttpRequest),"withCredentials"):_useXDomainRequest}function isXhrSupported(){var e=!1;try{e=!!getInst(strXMLHttpRequest)}catch(t){}return e}var UInt32Mask=4294967296,MaxUInt32=4294967295,SEED1=123456789,SEED2=987654321,_mwcSeeded=!1,_mwcW=SEED1,_mwcZ=SEED2;function _mwcSeed(e){e<0&&(e>>>=0),_mwcW=SEED1+e&MaxUInt32,_mwcZ=SEED2-e&MaxUInt32,_mwcSeeded=!0}function _autoSeedMwc(){try{var e=2147483647&utcNow();_mwcSeed((Math.random()*UInt32Mask^e)+e)}catch(t){}}function random32(e){var t=0,n=getCrypto()||getMsCrypto();return 0===(t=n&&n.getRandomValues?n.getRandomValues(new Uint32Array(1))[0]&MaxUInt32:t)&&isIE()&&(_mwcSeeded||_autoSeedMwc(),t=mwcRandom32()&MaxUInt32),0===t&&(t=mathFloor(UInt32Mask*Math.random()|0)),e||(t>>>=0),t}function mwcRandom32(e){var t=((_mwcZ=36969*(65535&_mwcZ)+(_mwcZ>>16)&MaxUInt32)<<16)+(65535&(_mwcW=18e3*(65535&_mwcW)+(_mwcW>>16)&MaxUInt32))>>>0&MaxUInt32|0;return e||(t>>>=0),t}function newId(e){void 0===e&&(e=22);for(var t=random32()>>>0,n=0,r=STR_EMPTY$1;r[_DYN_LENGTH$2]<e;)r+="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"[0|63&t]||"",t>>>=6,5==++n&&(t=(random32()<<2&4294967295|3&t)>>>0,n=0);return r}var version="3.3.7",instanceName="."+newId(6),_dataUid=0;function _canAcceptData(e){return 1===e.nodeType||9===e.nodeType||!+e.nodeType}function _getCache(e,t){var n=t[e.id];if(!n){n={};try{_canAcceptData(t)&&objDefine(t,e.id,{e:!1,v:n})}catch(r){}}return n}function createUniqueNamespace(e,t){return normalizeJsName(e+_dataUid+++((t=void 0!==t&&t)?"."+version:STR_EMPTY$1)+instanceName)}function createElmNodeData(e){var a={id:createUniqueNamespace("_aiData-"+(e||STR_EMPTY$1)+"."+version),accept:function(e){return _canAcceptData(e)},get:function(e,t,n,r){var o=e[a.id];return o?o[normalizeJsName(t)]:(r&&((o=_getCache(a,e))[normalizeJsName(t)]=n),n)},kill:function(e,t){if(e&&e[t])try{delete e[t]}catch(n){}}};return a}function _isConfigDefaults(e){return e&&isObject(e)&&(e.isVal||e.fb||objHasOwn(e,"v")||objHasOwn(e,"mrg")||objHasOwn(e,"ref")||e.set)}function _getDefault(e,t,n){var r,o=n.dfVal||isDefined;if(t&&n.fb){var a=n.fb;isArray(a)||(a=[a]);for(var i=0;i<a[_DYN_LENGTH$2];i++){var _=a[i],s=t[_];if(o(s)?r=s:e&&(o(s=e.cfg[_])&&(r=s),e.set(e.cfg,asString(_),s)),o(r))break}}return!o(r)&&o(n.v)?n.v:r}function _resolveDefaultValue(n,r,e){var o,t=e;return(t=e&&_isConfigDefaults(e)?_getDefault(n,r,e):t)&&(_isConfigDefaults(t)&&(t=_resolveDefaultValue(n,r,t)),isArray(t)?(o=[])[_DYN_LENGTH$2]=t[_DYN_LENGTH$2]:isPlainObject(t)&&(o={}),o&&(objForEachKey(t,function(e,t){t&&_isConfigDefaults(t)&&(t=_resolveDefaultValue(n,r,t)),o[e]=t}),t=o)),t}function _applyDefaultValue(n,e,t,r){var o,a,i,_,s,c,u=r,u=_isConfigDefaults(u)?(o=u.isVal,a=u.set,s=u.rdOnly,l=u.blkVal,i=u.mrg,!(_=u.ref)&&isUndefined(_)&&(_=!!i),_getDefault(n,e,u)):r,r=(l&&n.blkVal(e,t),!0),l=e[t];!l&&isNullOrUndefined(l)||(c=l,r=!1,o&&c!==u&&!o(c)&&(c=u,r=!0),a&&(r=(c=a(c,u,e))===u)),r?c=u&&_resolveDefaultValue(n,e,u):(isPlainObject(c)||isArray(u))&&i&&u&&(isPlainObject(u)||isArray(u))&&objForEachKey(u,function(e,t){_applyDefaultValue(n,c,e,t)}),n.set(e,t,c),_&&n.ref(e,t),s&&n.rdOnly(e,t)}var CFG_HANDLER_LINK=symbolFor("[[ai_dynCfg_1]]"),BLOCK_DYNAMIC=symbolFor("[[ai_blkDynCfg_1]]"),FORCE_DYNAMIC=symbolFor("[[ai_frcDynCfg_1]]");function _cfgDeepCopy(e){var n;return e&&(isArray(e)?(n=[])[_DYN_LENGTH$2]=e[_DYN_LENGTH$2]:isPlainObject(e)&&(n={}),n)?(objForEachKey(e,function(e,t){n[e]=_cfgDeepCopy(t)}),n):e}function getDynamicConfigHandler(e){if(e){var t=e[CFG_HANDLER_LINK]||e;if(t.cfg&&(t.cfg===e||t.cfg[CFG_HANDLER_LINK]===t))return t}return null}function blockDynamicConversion(e){if(e&&(isPlainObject(e)||isArray(e)))try{e[BLOCK_DYNAMIC]=!0}catch(t){}return e}function _canMakeDynamic(e,t,n){var r=!1;return!n||e[t.blkVal]||(r=n[FORCE_DYNAMIC])||n[BLOCK_DYNAMIC]?r:isPlainObject(n)||isArray(n)}function throwInvalidAccess(e){throwTypeError("InvalidAccess:"+e)}var arrayMethodsToPatch=["push","pop","shift","unshift","splice"],_throwDynamicError=function(e,t,n,r){e&&e[_DYN_THROW_INTERNAL](3,108,"".concat(n," [").concat(t,"] failed - ")+dumpObj(r))};function _patchArray(o,a,i){isArray(a)&&arrForEach(arrayMethodsToPatch,function(e){var r=a[e];a[e]=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var n=r[_DYN_APPLY](this,e);return _makeDynamicObject(o,a,i,"Patching"),n}})}function _getOwnPropGetter(e,t){e=objGetOwnPropertyDescriptor(e,t);return e&&e.get}function _createDynamicProperty(o,a,i,_){var s={n:i,h:[],trk:function(e){e&&e.fn&&(-1===arrIndexOf(s.h,e)&&s.h[_DYN_PUSH$1](e),o.trk(e,s))},clr:function(e){e=arrIndexOf(s.h,e);-1!==e&&s.h[_DYN_SPLICE](e,1)}},c=!0,u=!1;function l(){c&&(u=u||_canMakeDynamic(l,o,_),_&&!_[CFG_HANDLER_LINK]&&u&&(_=_makeDynamicObject(o,_,i,"Converting")),c=!1);var e=o.act;return e&&s.trk(e),_}l[o.prop]={chng:function(){o.add(s)}},objDefine(a,s.n,{g:l,s:function(t){if(_!==t){l[o.ro]&&!o.upd&&throwInvalidAccess("["+i+"] is read-only:"+dumpObj(a)),c&&(u=u||_canMakeDynamic(l,o,_),c=!1);var e,n=u&&l[o.rf];if(u)if(n){objForEachKey(_,function(e){_[e]=t?t[e]:UNDEFINED_VALUE$1});try{objForEachKey(t,function(e,t){_setDynamicProperty(o,_,e,t)}),t=_}catch(r){_throwDynamicError((o.hdlr||{})[_DYN_LOGGER],i,"Assigning",r),u=!1}}else _&&_[CFG_HANDLER_LINK]&&objForEachKey(_,function(e){var e=_getOwnPropGetter(_,e);e&&(e=e[o.prop])&&e.chng()});t!==_&&(e=t&&_canMakeDynamic(l,o,t),!n&&e&&(t=_makeDynamicObject(o,t,i,"Converting")),_=t,u=e),o.add(s)}}})}function _setDynamicProperty(e,t,n,r){var o;return t&&((o=_getOwnPropGetter(t,n))&&o[e.prop]?t[n]=r:_createDynamicProperty(e,t,n,r)),t}function _setDynamicPropertyState(e,t,n,r){if(t){var o=_getOwnPropGetter(t,n),a=o&&!!o[e.prop],i=r&&r[0],_=r&&r[1],r=r&&r[2];if(!a){if(r)try{blockDynamicConversion(t)}catch(s){_throwDynamicError((e.hdlr||{})[_DYN_LOGGER],n,"Blocking",s)}try{_setDynamicProperty(e,t,n,t[n]),o=_getOwnPropGetter(t,n)}catch(s){_throwDynamicError((e.hdlr||{})[_DYN_LOGGER],n,"State",s)}}i&&(o[e.rf]=i),_&&(o[e.ro]=_),r&&(o[e.blkVal]=!0)}return t}function _makeDynamicObject(n,r,e,t){try{objForEachKey(r,function(e,t){_setDynamicProperty(n,r,e,t)}),r[CFG_HANDLER_LINK]||(objDefineProp(r,CFG_HANDLER_LINK,{get:function(){return n.hdlr}}),_patchArray(n,r,e))}catch(o){_throwDynamicError((n.hdlr||{})[_DYN_LOGGER],e,t,o)}return r}var symPrefix="[[ai_",symPostfix="]]";function _createState(a){var i,e=newSymbol(symPrefix+"get"+a.uid+symPostfix),t=newSymbol(symPrefix+"ro"+a.uid+symPostfix),n=newSymbol(symPrefix+"rf"+a.uid+symPostfix),r=newSymbol(symPrefix+"blkVal"+a.uid+symPostfix),_=newSymbol(symPrefix+"dtl"+a.uid+symPostfix),o=null,s=null;function c(t,e){var n=i.act;try{(i.act=t)&&t[_]&&(arrForEach(t[_],function(e){e.clr(t)}),t[_]=[]),e({cfg:a.cfg,set:a.set.bind(a),setDf:a.setDf.bind(a),ref:a.ref.bind(a),rdOnly:a.rdOnly.bind(a)})}catch(o){var r=a[_DYN_LOGGER];throw r&&r[_DYN_THROW_INTERNAL](1,107,dumpObj(o)),o}finally{i.act=n||null}}function u(){if(o){var e=o,n=(o=null,s&&s[_DYN_CANCEL](),s=null,[]);if(arrForEach(e,function(t){if(t&&(t[_]&&(arrForEach(t[_],function(e){e.clr(t)}),t[_]=null),t.fn))try{c(t,t.fn)}catch(e){n[_DYN_PUSH$1](e)}}),o)try{u()}catch(t){n[_DYN_PUSH$1](t)}0<n[_DYN_LENGTH$2]&&throwAggregationError("Watcher error(s): ",n)}}return i={prop:e,ro:t,rf:n,blkVal:r,hdlr:a,add:function(e){if(e&&0<e.h[_DYN_LENGTH$2]){o=o||[],s=s||scheduleTimeout(function(){s=null,u()},0);for(var t=0;t<e.h[_DYN_LENGTH$2];t++){var n=e.h[t];n&&-1===arrIndexOf(o,n)&&o[_DYN_PUSH$1](n)}}},notify:u,use:c,trk:function(e,t){e&&(e=e[_]=e[_]||[],-1===arrIndexOf(e,t)&&e[_DYN_PUSH$1](t))}}}function _createAndUseHandler(e,t){var n={fn:t,rm:function(){n.fn=null,t=e=null}};return objDefine(n,"toJSON",{v:function(){return"WatcherHandler"+(n.fn?"":"[X]")}}),e.use(n,t),n}function _createDynamicHandler(o,e,t){var n=getDynamicConfigHandler(e);if(n)return n;var a,n=createUniqueNamespace("dyncfg",!0),t=e&&!1!==t?e:_cfgDeepCopy(e),r={uid:null,cfg:t,logger:o,notify:function(){a.notify()},set:function(e,t,n){try{e=_setDynamicProperty(a,e,t,n)}catch(r){_throwDynamicError(o,t,"Setting value",r)}return e[t]},setDf:function(n,e){return e&&objForEachKey(e,function(e,t){_applyDefaultValue(r,n,e,t)}),n},watch:function(e){return _createAndUseHandler(a,e)},ref:function(e,t){return _setDynamicPropertyState(a,e,t,((e={})[0]=!0,e))[t]},rdOnly:function(e,t){return _setDynamicPropertyState(a,e,t,((e={})[1]=!0,e))[t]},blkVal:function(e,t){return _setDynamicPropertyState(a,e,t,((e={})[2]=!0,e))[t]},_block:function(n,r){a.use(null,function(e){var t=a.upd;try{isUndefined(r)||(a.upd=r),n(e)}finally{a.upd=t}})}};return objDefine(r,"uid",{c:!1,e:!1,w:!1,v:n}),_makeDynamicObject(a=_createState(r),t,"config","Creating"),r}function _logInvalidAccess(e,t){e?(e[_DYN_WARN_TO_CONSOLE](t),e[_DYN_THROW_INTERNAL](2,108,t)):throwInvalidAccess(t)}function createDynamicConfig(e,t,n,r){n=_createDynamicHandler(n,e||{},r);return t&&n.setDf(n.cfg,t),n}function onConfigChange(e,t,n){var r=e[CFG_HANDLER_LINK]||e;return!r.cfg||r.cfg!==e&&r.cfg[CFG_HANDLER_LINK]!==r?(_logInvalidAccess(n,STR_NOT_DYNAMIC_ERROR+dumpObj(e)),createDynamicConfig(e,null,n)[_DYN_WATCH](t)):r[_DYN_WATCH](t)}function runTargetUnload(e,t){if(e&&e[_DYN_UNLOAD])return e[_DYN_UNLOAD](t)}var DisabledPropertyName="Microsoft_ApplicationInsights_BypassAjaxInstrumentation";function _stringToBoolOrDefault(e,t,n){return!e&&isNullOrUndefined(e)?t:isBoolean(e)?e:"true"===asString(e)[_DYN_TO_LOWER_CASE$1]()}function cfgDfValidate(e,t,n){return{fb:n,isVal:e,v:t}}function cfgDfBoolean(e,t){return{fb:t,set:_stringToBoolOrDefault,v:!!e}}var _a$2,_aiNamespace=null;function _getExtensionNamespace(){var e=getInst("Microsoft");return _aiNamespace=e?e.ApplicationInsights:_aiNamespace}function getDebugExt(e){var t=_aiNamespace;return(t=t||!0===e.disableDbgExt?t:_aiNamespace||_getExtensionNamespace())?t.ChromeDbgExt:null}var STR_WARN_TO_CONSOLE="warnToConsole",AiNonUserActionablePrefix="AI (Internal): ",AiUserActionablePrefix="AI: ",AIInternalMessagePrefix="AITR_",defaultValues$1={loggingLevelConsole:0,loggingLevelTelemetry:1,maxMessageLimit:25,enableDebug:!1},_logFuncs=((_a$2={})[0]=null,_a$2[1]="errorToConsole",_a$2[2]=STR_WARN_TO_CONSOLE,_a$2[3]="debugToConsole",_a$2);function _sanitizeDiagnosticText(e){return e?'"'+e[_DYN_REPLACE](/\"/g,STR_EMPTY$1)+'"':STR_EMPTY$1}function _logToConsole(e,t){var n,r=getConsole();r&&(n="log",r[e]&&(n=e),isFunction(r[n])&&r[n](t))}var _InternalLogMessage=function(){function e(e,t,n,r){void 0===n&&(n=!1),this[_DYN_MESSAGE_ID]=e,this[_DYN_MESSAGE$1]=(n?AiUserActionablePrefix:AiNonUserActionablePrefix)+e;n=STR_EMPTY$1,hasJSON()&&(n=getJSON().stringify(r)),e=(t?" message:"+_sanitizeDiagnosticText(t):STR_EMPTY$1)+(r?" props:"+_sanitizeDiagnosticText(n):STR_EMPTY$1);this[_DYN_MESSAGE$1]+=e}return e.dataType="MessageData",e}();function safeGetLogger(e,t){return(e||{})[_DYN_LOGGER]||new DiagnosticLogger(t)}var DiagnosticLogger=function(){function e(r){this.identifier="DiagnosticLogger",this.queue=[];var s,o,c,u,t,l=0,N={};dynamicProto(e,this,function(a){function i(e,t){var n,r;c<=l||(r=!0,n=AIInternalMessagePrefix+t[_DYN_MESSAGE_ID],N[n]?r=!1:N[n]=!0,r&&(e<=o&&(a.queue[_DYN_PUSH$1](t),l++,_(1===e?"error":"warn",t)),l===c&&(r=new _InternalLogMessage(23,n="Internal events throttle limit per PageView reached for this app.",!1),a.queue[_DYN_PUSH$1](r),1===e?a.errorToConsole(n):a[_DYN_WARN_TO_CONSOLE](n))))}function _(e,t){var n=getDebugExt(r||{});n&&n[_DYN_DIAG_LOG$1]&&n[_DYN_DIAG_LOG$1](e,t)}t=onConfigChange(createDynamicConfig(r||{},defaultValues$1,a).cfg,function(e){e=e.cfg;s=e[_DYN_LOGGING_LEVEL_CONSOL4],o=e.loggingLevelTelemetry,c=e.maxMessageLimit,u=e.enableDebug}),a.consoleLoggingLevel=function(){return s},a[_DYN_THROW_INTERNAL]=function(e,t,n,r,o){t=new _InternalLogMessage(t,n,o=void 0!==o&&o,r);if(u)throw dumpObj(t);n=_logFuncs[e]||STR_WARN_TO_CONSOLE;isUndefined(t[_DYN_MESSAGE$1])?_("throw"+(1===e?"Critical":"Warning"),t):(o?(r=+t[_DYN_MESSAGE_ID],!N[r]&&e<=s&&(a[n](t[_DYN_MESSAGE$1]),N[r]=!0)):e<=s&&a[n](t[_DYN_MESSAGE$1]),i(e,t))},a.debugToConsole=function(e){_logToConsole("debug",e),_("warning",e)},a[_DYN_WARN_TO_CONSOLE]=function(e){_logToConsole("warn",e),_("warning",e)},a.errorToConsole=function(e){_logToConsole("error",e),_("error",e)},a.resetInternalMessageCount=function(){l=0,N={}},a.logInternalMessage=i,a[_DYN_UNLOAD]=function(e){t&&t.rm(),t=null}})}return e.__ieDyn=1,e}();function _getLogger(e){return e||new DiagnosticLogger}function _throwInternal(e,t,n,r,o,a){void 0===a&&(a=!1),_getLogger(e)[_DYN_THROW_INTERNAL](t,n,r,o,a)}function _warnToConsole(e,t){_getLogger(e)[_DYN_WARN_TO_CONSOLE](t)}var strExecutionContextKey="ctx",strParentContextKey="ParentContextKey",strChildrenContextKey="ChildrenContextKey",PerfEvent=function(){function a(e,t,n){var r,o=this;o.start=utcNow(),o[_DYN_NAME$2]=e,o.isAsync=n,o[_DYN_IS_CHILD_EVT]=function(){return!1},isFunction(t)&&objDefine(o,"payload",{g:function(){return!r&&isFunction(t)&&(r=t(),t=null),r}}),o[_DYN_GET_CTX]=function(e){return e?(e===a[strParentContextKey]||e===a[strChildrenContextKey]?o:o[strExecutionContextKey]||{})[e]:null},o[_DYN_SET_CTX]=function(e,t){e&&(e===a[strParentContextKey]?(o[e]||(o[_DYN_IS_CHILD_EVT]=function(){return!0}),o[e]=t):e===a[strChildrenContextKey]?o[e]=t:(o[strExecutionContextKey]=o[strExecutionContextKey]||{})[e]=t)},o.complete=function(){var e=0,t=o[_DYN_GET_CTX](a[strChildrenContextKey]);if(isArray(t))for(var n=0;n<t[_DYN_LENGTH$2];n++){var r=t[n];r&&(e+=r.time)}o.time=utcNow()-o.start,o.exTime=o.time-e,o.complete=function(){}}}return a.ParentContextKey="parent",a.ChildrenContextKey="childEvts",a}(),doPerfActiveKey="CoreUtils.doPerf";function doPerf(e,t,n,r,o){if(e)if(e=e[STR_GET_PERF_MGR]?e[STR_GET_PERF_MGR]():e){var a,i=void 0,_=e[_DYN_GET_CTX](doPerfActiveKey);try{if(i=e.create(t(),r,o))return _&&i[_DYN_SET_CTX]&&(i[_DYN_SET_CTX](PerfEvent[strParentContextKey],_),_[_DYN_GET_CTX]&&_[_DYN_SET_CTX]&&((a=_[_DYN_GET_CTX](PerfEvent[strChildrenContextKey]))||(a=[],_[_DYN_SET_CTX](PerfEvent[strChildrenContextKey],a)),a[_DYN_PUSH$1](i))),e[_DYN_SET_CTX](doPerfActiveKey,i),n(i)}catch(s){i&&i[_DYN_SET_CTX]&&i[_DYN_SET_CTX]("exception",s)}finally{i&&e.fire(i),e[_DYN_SET_CTX](doPerfActiveKey,_)}}return n()}var pluginStateData=createElmNodeData("plugin");function _getPluginState(e){return pluginStateData.get(e,"state",{},!0)}var _a$1,strTelemetryPluginChain="TelemetryPluginChain",strHasRunFlags="_hasRun",strGetTelCtx="_getTelCtx",_chainId=0;function _getNextProxyStart(e,t,n){for(;e;){if(e[_DYN_GET_PLUGIN]()===n)return e;e=e[_DYN_GET_NEXT]()}return createTelemetryProxyChain([n],t.config||{},t)}function _createInternalContext(e,a,n,t){var r=null,o=[],i=(a=a||createDynamicConfig({},null,n[_DYN_LOGGER]),null!==t&&(r=t?_getNextProxyStart(e,n,t):e),{_next:function(){var e,t=r;return r=t?t[_DYN_GET_NEXT]():null,t||(e=o)&&0<e[_DYN_LENGTH$2]&&(arrForEach(e,function(e){try{e.func.call(e.self,e.args)}catch(t){_throwInternal(n[_DYN_LOGGER],2,73,"Unexpected Exception during onComplete - "+dumpObj(t))}}),o=[]),t},ctx:{core:function(){return n},diagLog:function(){return safeGetLogger(n,a.cfg)},getCfg:function(){return a.cfg},getExtCfg:function(e,t){var r=_(e,!0);return t&&objForEachKey(t,function(e,t){var n;!isNullOrUndefined(r[e])||!(n=a.cfg[e])&&isNullOrUndefined(n)||(r[e]=n),_applyDefaultValue(a,r,e,t)}),a.setDf(r,t)},getConfig:function(e,t,n){void 0===n&&(n=!1);var r,e=_(e,!1),o=a.cfg;return!e||!e[t]&&isNullOrUndefined(e[t])?!o[t]&&isNullOrUndefined(o[t])||(r=o[t]):r=e[t],r||!isNullOrUndefined(r)?r:n},hasNext:function(){return!!r},getNext:function(){return r},setNext:function(e){r=e},iterate:function(e){for(;t=i._next();){var t=t[_DYN_GET_PLUGIN]();t&&e(t)}},onComplete:function(e,t){for(var n=[],r=2;r<arguments.length;r++)n[r-2]=arguments[r];e&&o[_DYN_PUSH$1]({func:e,self:isUndefined(t)?i.ctx:t,args:n})}}});function _(e,t){var n,r=null,o=a.cfg;return o&&e&&(n=o[STR_EXTENSION_CONFIG],o[STR_EXTENSION_CONFIG]=n=!n&&t?{}:n,(n=a.ref(o,STR_EXTENSION_CONFIG))&&(r=n[e],n[e]=r=!r&&t?{}:r,r=a.ref(n,e))),r}return i}function createProcessTelemetryContext(e,t,n,r){var o=createDynamicConfig(t),a=_createInternalContext(e,o,n,r),i=a.ctx;return i[_DYN_PROCESS_NEXT]=function(e){var t=a._next();return t&&t[STR_PROCESS_TELEMETRY](e,i),!t},i[_DYN_CREATE_NEW]=function(e,t){return createProcessTelemetryContext((e=isArray(e=void 0===e?null:e)?createTelemetryProxyChain(e,o.cfg,n,t):e)||i[_DYN_GET_NEXT](),o.cfg,n,t)},i}function createProcessTelemetryUnloadContext(e,n,t){var r=createDynamicConfig(n.config),o=_createInternalContext(e,r,n,t),a=o.ctx;return a[_DYN_PROCESS_NEXT]=function(e){var t=o._next();return t&&t[_DYN_UNLOAD](a,e),!t},a[_DYN_CREATE_NEW]=function(e,t){return createProcessTelemetryUnloadContext((e=isArray(e=void 0===e?null:e)?createTelemetryProxyChain(e,r.cfg,n,t):e)||a[_DYN_GET_NEXT](),n,t)},a}function createProcessTelemetryUpdateContext(e,n,t){var r=createDynamicConfig(n.config),o=_createInternalContext(e,r,n,t).ctx;return o[_DYN_PROCESS_NEXT]=function(t){return o.iterate(function(e){isFunction(e[_DYN_UPDATE])&&e[_DYN_UPDATE](o,t)})},o[_DYN_CREATE_NEW]=function(e,t){return createProcessTelemetryUpdateContext((e=isArray(e=void 0===e?null:e)?createTelemetryProxyChain(e,r.cfg,n,t):e)||o[_DYN_GET_NEXT](),n,t)},o}function createTelemetryProxyChain(e,t,n,r){var o,a=null,i=!r;return isArray(e)&&0<e[_DYN_LENGTH$2]&&(o=null,arrForEach(e,function(e){(i=!i&&r===e||i)&&e&&isFunction(e[STR_PROCESS_TELEMETRY])&&(e=createTelemetryPluginProxy(e,t,n),a=a||e,o&&o._setNext(e),o=e)})),r&&!a?createTelemetryProxyChain([r],t,n):a}function createTelemetryPluginProxy(s,r,o){var c=null,a=isFunction(s[STR_PROCESS_TELEMETRY]),i=isFunction(s[_DYN_SET_NEXT_PLUGIN]),u=s?s[_DYN_IDENTIFIER]+"-"+s[STR_PRIORITY]+"-"+_chainId++:"Unknown-0-"+_chainId++,_={getPlugin:function(){return s},getNext:function(){return c},processTelemetry:function(n,e){var t;l(e=e||(t=(t=s&&isFunction(s[strGetTelCtx])?s[strGetTelCtx]():t)||createProcessTelemetryContext(_,r,o)),function(e){if(!s||!a)return!1;var t=_getPluginState(s);return!t[_DYN_TEARDOWN]&&!t[STR_DISABLED]&&(i&&s[_DYN_SET_NEXT_PLUGIN](c),s[STR_PROCESS_TELEMETRY](n,e),!0)},"processTelemetry",function(){return{item:n}},!n.sync)||e[_DYN_PROCESS_NEXT](n)},unload:function(r,o){l(r,function(){var e,t,n=!1;return s&&(e=_getPluginState(s),t=s[STR_CORE]||e[STR_CORE],!s||t&&t!==r.core()||e[_DYN_TEARDOWN]||(e[STR_CORE]=null,e[_DYN_TEARDOWN]=!0,e[_DYN_IS_INITIALIZED]=!1,s[_DYN_TEARDOWN]&&!0===s[_DYN_TEARDOWN](r,o)&&(n=!0))),n},"unload",function(){},o.isAsync)||r[_DYN_PROCESS_NEXT](o)},update:function(r,o){l(r,function(){var e,t,n=!1;return s&&(e=_getPluginState(s),t=s[STR_CORE]||e[STR_CORE],!s||t&&t!==r.core()||e[_DYN_TEARDOWN]||s[_DYN_UPDATE]&&!0===s[_DYN_UPDATE](r,o)&&(n=!0)),n},"update",function(){},!1)||r[_DYN_PROCESS_NEXT](o)},_id:u,_setNext:function(e){c=e}};function l(n,r,o,e,t){var a=!1,i=s?s[_DYN_IDENTIFIER]:strTelemetryPluginChain,_=(_=n[strHasRunFlags])||(n[strHasRunFlags]={});return n.setNext(c),s&&doPerf(n[STR_CORE](),function(){return i+":"+o},function(){_[u]=!0;try{var e=c?c._id:STR_EMPTY$1;e&&(_[e]=!1),a=r(n)}catch(t){e=!c||_[c._id];e&&(a=!0),c&&e||_throwInternal(n[_DYN_DIAG_LOG$1](),1,73,"Plugin ["+i+"] failed during "+o+" - "+dumpObj(t)+", run flags: "+dumpObj(_))}},e,t),a}return objFreeze(_)}function createUnloadHandlerContainer(){var t=[];return{add:function(e){e&&t[_DYN_PUSH$1](e)},run:function(n,r){arrForEach(t,function(e){try{e(n,r)}catch(t){_throwInternal(n[_DYN_DIAG_LOG$1](),2,73,"Unexpected error calling unload handler - "+dumpObj(t))}}),t=[]}}}function createUnloadHookContainer(){var t=[];return{run:function(n){var e=t;t=[],arrForEach(e,function(e){try{(e.rm||e.remove).call(e)}catch(t){_throwInternal(n,2,73,"Unloading:"+dumpObj(t))}})},add:function(e){e&&arrAppend(t,e)}}}var strGetPlugin="getPlugin",defaultValues=((_a$1={})[STR_EXTENSION_CONFIG]={isVal:isNotNullOrUndefined,v:{}},_a$1),BaseTelemetryPlugin=function(){function e(){var o,a,c,u,l,i=this;function t(e){var t,e=e=void 0===e?null:e;return e||(t=a||createProcessTelemetryContext(null,{},i[STR_CORE]),e=c&&c[strGetPlugin]?t[_DYN_CREATE_NEW](null,c[strGetPlugin]):t[_DYN_CREATE_NEW](null,c)),e}function _(e,t,n){createDynamicConfig(e,defaultValues,safeGetLogger(t)),!n&&t&&(n=t[_DYN_GET_PROCESS_TEL_CONT2]()[_DYN_GET_NEXT]());var r=c;c&&c[strGetPlugin]&&(r=c[strGetPlugin]()),i[STR_CORE]=t,a=createProcessTelemetryContext(n,e,t,r)}function N(){o=!1,i[STR_CORE]=null,c=a=null,l=createUnloadHookContainer(),u=createUnloadHandlerContainer()}N(),dynamicProto(e,i,function(s){s[_DYN_INITIALIZE$1]=function(e,t,n,r){_(e,t,r),o=!0},s[_DYN_TEARDOWN]=function(e,t){var n,r,o,a,i=s[STR_CORE];if(i&&(!e||i===e[STR_CORE]()))return r=!1,o=e||createProcessTelemetryUnloadContext(null,i,c&&c[strGetPlugin]?c[strGetPlugin]():c),a=t||{reason:0,isAsync:!1},s[_DYN__DO_TEARDOWN]&&!0===s[_DYN__DO_TEARDOWN](o,a,_)?n=!0:_(),n;function _(){r||(r=!0,u.run(o,t),l.run(o[_DYN_DIAG_LOG$1]()),!0===n&&o[_DYN_PROCESS_NEXT](a),N())}},s[_DYN_UPDATE]=function(e,t){var n,r,o,a=s[STR_CORE];if(a&&(!e||a===e[STR_CORE]()))return r=!1,o=e||createProcessTelemetryUpdateContext(null,a,c&&c[strGetPlugin]?c[strGetPlugin]():c),s._doUpdate&&!0===s._doUpdate(o,t||{reason:0},i)?n=!0:i(),n;function i(){r||(r=!0,_(o.getCfg(),o.core(),o[_DYN_GET_NEXT]()))}},proxyFunctionAs(s,"_addUnloadCb",function(){return u},"add"),proxyFunctionAs(s,"_addHook",function(){return l},"add"),objDefine(s,"_unloadHooks",{g:function(){return l}})}),i[_DYN_DIAG_LOG$1]=function(e){return t(e)[_DYN_DIAG_LOG$1]()},i[_DYN_IS_INITIALIZED]=function(){return o},i.setInitialized=function(e){o=e},i[_DYN_SET_NEXT_PLUGIN]=function(e){c=e},i[_DYN_PROCESS_NEXT]=function(e,t){t?t[_DYN_PROCESS_NEXT](e):c&&isFunction(c[STR_PROCESS_TELEMETRY])&&c[STR_PROCESS_TELEMETRY](e,null)},i._getTelCtx=t}return e.__ieDyn=1,e}();function parseResponse(e,t){try{if(e&&""!==e){var n=getJSON().parse(e);if(n&&n[_DYN_ITEMS_RECEIVED$1]&&n[_DYN_ITEMS_RECEIVED$1]>=n.itemsAccepted&&n.itemsReceived-n.itemsAccepted===n.errors[_DYN_LENGTH$2])return n}}catch(r){_throwInternal(t,1,43,"Cannot parse the response. "+(r[_DYN_NAME$2]||dumpObj(r)),{response:e})}return null}var STR_EMPTY="",STR_NO_RESPONSE_BODY="NoResponseBody",_noResponseQs="&"+STR_NO_RESPONSE_BODY+"=true",STR_POST_METHOD="POST",SenderPostManager=function(){function e(){var g,o,N,m,y,a,Y,E,f,D,d,A,I,O,v=0;dynamicProto(e,this,function(n,e){var T=!0;function _(e,t){_throwInternal(N,2,26,"Failed to send telemetry.",{message:e}),p(t,400,{})}function S(e){_("No endpoint url is provided for the batch",e)}function p(e,t,n,r){try{e&&e(t,n,r)}catch(o){}}function i(e,t){var n=getNavigator();if(!e[_DYN_URL_STRING])return S(t),!0;t=e[_DYN_URL_STRING]+(I?_noResponseQs:STR_EMPTY),e=e[_DYN_DATA$1],e=m?e:new Blob([e],{type:"text/plain;charset=UTF-8"});return n.sendBeacon(t,e)}function s(e,t,n){var r,o=e[_DYN_DATA$1];try{o&&(i(e,t)?p(t,200,{},STR_EMPTY):(r=y&&y.beaconOnRetry)&&isFunction(r)?r(e,t,i):(E&&E.sendPOST(e,t,!0),_throwInternal(N,2,40,". Failed to send telemetry with Beacon API, retried with normal sender.")))}catch(a){m&&_warnToConsole(N,"Failed to send telemetry using sendBeacon API. Ex:"+dumpObj(a)),p(t,m?0:400,{},STR_EMPTY)}}function c(n,r,e){var t,o,a,i=n[_DYN_HEADERS]||{},_=(!e&&g&&(t=createPromise(function(e,t){o=e,a=t})),m&&e&&n.disableXhrSync&&(e=!1),n[_DYN_URL_STRING]);if(!_)return S(r),void(o&&o(!1));var s=openXhr(STR_POST_METHOD,_,T,!0,e,n[_DYN_TIMEOUT]);function c(e){var t=y&&y.xhrOnComplete;t&&isFunction(t)?t(e,r,n):(t=getResponseText(e),p(r,e[_DYN_STATUS],_getAllResponseHeaders(e,m),t))}return m||s.setRequestHeader("Content-type","application/json"),arrForEach(objKeys(i),function(e){s.setRequestHeader(e,i[e])}),s.onreadystatechange=function(){m||(c(s),4===s.readyState&&o&&o(!0))},s.onload=function(){m&&c(s)},s.onerror=function(e){p(r,m?s[_DYN_STATUS]:400,_getAllResponseHeaders(s,m),m?STR_EMPTY:formatErrorMessageXhr(s)),a&&a(e)},s.ontimeout=function(){p(r,m?s[_DYN_STATUS]:500,_getAllResponseHeaders(s,m),m?STR_EMPTY:formatErrorMessageXhr(s)),o&&o(!1)},s.send(n[_DYN_DATA$1]),t}function u(n,a,r){var e,o,i,t=n[_DYN_URL_STRING],_=n[_DYN_DATA$1],s=m?_:new Blob([_],{type:"application/json"}),c=new Headers,u=_[_DYN_LENGTH$2],_=!1,l=!1,N=n[_DYN_HEADERS]||{},E=((s={method:STR_POST_METHOD,body:s})[DisabledPropertyName]=!0,n.headers&&0<objKeys(n.headers)[_DYN_LENGTH$2]&&(arrForEach(objKeys(N),function(e){c.append(e,N[e])}),s[_DYN_HEADERS]=c),Y?s.credentials=Y:T&&m&&(s.credentials="include"),r&&(s.keepalive=!0,v+=u,m?2===n._sendReason&&(_=!0,I&&(t+=_noResponseQs)):_=!0),new Request(t,s));try{E[DisabledPropertyName]=!0}catch(d){}if(!r&&g&&(e=createPromise(function(e,t){o=e,i=t})),!t)return S(a),void(o&&o(!1));function f(e,t){p(a,t?m?0:t:m?0:400,{},m?STR_EMPTY:e)}function D(e,t,n){var r=e[_DYN_STATUS],o=y.fetchOnComplete;o&&isFunction(o)?o(e,a,n||STR_EMPTY,t):p(a,r,{},n||STR_EMPTY)}try{doAwaitResponse(fetch(m?t:E,m?s:null),function(e){if(r&&(v-=u,u=0),!l)if(l=!0,e.rejected)f(e.reason&&e.reason[_DYN_MESSAGE$1],499),i&&i(e.reason);else{var t=e[_DYN_VALUE];try{m||t.ok?m&&!t.body?(D(t,null,STR_EMPTY),o&&o(!0)):doAwaitResponse(t.text(),function(e){D(t,n,e[_DYN_VALUE]),o&&o(!0)}):(t[_DYN_STATUS]?f(t.statusText,t[_DYN_STATUS]):f(t.statusText,499),o&&o(!1))}catch(d){t&&t[_DYN_STATUS]?f(dumpObj(d),t[_DYN_STATUS]):f(dumpObj(d),499),i&&i(d)}}})}catch(d){l||(f(dumpObj(d),499),i&&i(d))}return _&&!l&&(l=!0,p(a,200,{}),o&&o(!0)),m&&!l&&0<n[_DYN_TIMEOUT]&&O&&O.set(function(){l||(l=!0,p(a,500,{}),o&&o(!0))},n[_DYN_TIMEOUT]),e}function l(n,r,e){var t=getWindow(),o=new XDomainRequest,a=n[_DYN_DATA$1],t=(o.onload=function(){var e=getResponseText(o),t=y&&y.xdrOnComplete;t&&isFunction(t)?t(o,r,n):p(r,200,{},e)},o.onerror=function(){p(r,400,{},m?STR_EMPTY:formatErrorMessageXdr(o))},o.ontimeout=function(){p(r,500,{})},o.onprogress=function(){},t&&t.location&&t.location.protocol||""),i=n[_DYN_URL_STRING];if(i){if(!m&&i.lastIndexOf(t,0))return _throwInternal(N,2,40,". Cannot send XDomain request. The endpoint URL protocol doesn't match the hosting page protocol."),void _("Cannot send XDomain request. The endpoint URL protocol doesn't match the hosting page protocol.",r);t=m?i:i[_DYN_REPLACE](/^(https?:)/,"");o.open(STR_POST_METHOD,t),n[_DYN_TIMEOUT]&&(o[_DYN_TIMEOUT]=n[_DYN_TIMEOUT]),o.send(a),m&&e?O&&O.set(function(){o.send(a)},0):o.send(a)}else S(r)}function r(){v=0,I=A=d=D=f=g=o=!1,O=E=Y=a=y=m=N=null}r(),n[_DYN_INITIALIZE$1]=function(e,t){N=t,o&&_throwInternal(N,1,28,"Sender is already initialized"),n.SetConfig(e),o=!0},n._getDbgPlgTargets=function(){return[o,m,a,g]},n.SetConfig=function(e){try{var t;return y=e.senderOnCompleteCallBack||{},a=!!e.disableCredentials,Y=e.fetchCredentials,m=!!e.isOneDs,g=!!e.enableSendPromise,f=!!e.disableXhr,D=!!e.disableBeacon,d=!!e.disableBeaconSync,O=e.timeWrapper,I=!!e.addNoResponse,A=!!e.disableFetchKeepAlive,E={sendPOST:c},m||(T=!1),a&&(t=getLocation())&&t.protocol&&"file:"===t.protocol[_DYN_TO_LOWER_CASE$1]()&&(T=!1),!0}catch(n){}return!1},n.getSyncFetchPayload=function(){return v},n.getSenderInst=function(e,t){if(e&&e[_DYN_LENGTH$2]){for(var n=e,r=t,o=0,a=null,i=0;null==a&&i<n[_DYN_LENGTH$2];)o=n[i],f||1!==o?2!==o||!isFetchSupported(r)||r&&A?3!==o||!isBeaconsSupported()||(r?d:D)||(a=s):a=u:useXDomainRequest()?a=l:isXhrSupported()&&(a=c),i++;return a?{_transport:o,_isSync:r,sendPOST:a}:null}return null},n.getFallbackInst=function(){return E},n[_DYN__DO_TEARDOWN]=function(e,t){r()},n.preparePayload=function(i,e,_,t){if(e&&!t&&_[_DYN_DATA$1])try{var s,c,u,l,n=getInst("CompressionStream");if(isFunction(n))return s=new ReadableStream({start:function(e){e.enqueue(isString(_[_DYN_DATA$1])?(new TextEncoder).encode(_[_DYN_DATA$1]):_[_DYN_DATA$1]),e.close()}}).pipeThrough(new n("gzip")).getReader(),u=0,l=!(c=[]),doAwaitResponse(s.read(),function N(e){if(!l&&!e.rejected){e=e[_DYN_VALUE];if(!e.done)return c[_DYN_PUSH$1](e[_DYN_VALUE]),u+=e.value[_DYN_LENGTH$2],doAwaitResponse(s.read(),N);for(var t=new Uint8Array(u),n=0,r=0,o=c;r<o.length;r++){var a=o[r];t.set(a,n),n+=a[_DYN_LENGTH$2]}_[_DYN_DATA$1]=t,_[_DYN_HEADERS]["Content-Encoding"]="gzip",_._chunkCount=c[_DYN_LENGTH$2]}l||(l=!0,i(_))}),s;i(_)}catch(r){return void i(_)}else i(_)}})}return e.__ieDyn=1,e}(),strOnPrefix="on",strAttachEvent="attachEvent",strAddEventHelper="addEventListener",strDetachEvent="detachEvent",strRemoveEventListener="removeEventListener",strEvents="events",rRemoveEmptyNs=(createUniqueNamespace("aiEvtPageHide"),createUniqueNamespace("aiEvtPageShow"),/\.[\.]+/g),rRemoveTrailingEmptyNs=/[\.]+$/,_guid=1,elmNodeData=createElmNodeData("events"),eventNamespace=/^([^.]*)(?:\.(.+)|)/;function _normalizeNamespace(e){return e&&e[_DYN_REPLACE]?e[_DYN_REPLACE](/^[\s\.]+|(?=[\s\.])[\.\s]+$/g,STR_EMPTY$1):e}function _getEvtNamespace(e,t){t&&(n=STR_EMPTY$1,isArray(t)?(n=STR_EMPTY$1,arrForEach(t,function(e){(e=_normalizeNamespace(e))&&("."!==e[0]&&(e="."+e),n+=e)})):n=_normalizeNamespace(t),n&&("."!==n[0]&&(n="."+n),e=(e||STR_EMPTY$1)+n));var n,t=eventNamespace.exec(e||STR_EMPTY$1)||[];return{type:t[1],ns:(t[2]||STR_EMPTY$1).replace(rRemoveEmptyNs,".").replace(rRemoveTrailingEmptyNs,STR_EMPTY$1)[_DYN_SPLIT$1](".").sort().join(".")}}function _getRegisteredEvents(e,t,n){e=elmNodeData.get(e,strEvents,{},n=void 0===n||n);return e[t]||(e[t]=[])}function _doDetach(e,t,n,r){e&&t&&t[_DYN_TYPE]&&(e[strRemoveEventListener]?e[strRemoveEventListener](t[_DYN_TYPE],n,r):e[strDetachEvent]&&e[strDetachEvent](strOnPrefix+t[_DYN_TYPE],n))}function _doAttach(e,t,n,r){var o=!1;return e&&t&&t[_DYN_TYPE]&&n&&(e[strAddEventHelper]?(e[strAddEventHelper](t[_DYN_TYPE],n,r),o=!0):e[strAttachEvent]&&(e[strAttachEvent](strOnPrefix+t[_DYN_TYPE],n),o=!0)),o}function _doUnregister(e,t,n,r){for(var o=t[_DYN_LENGTH$2];o--;){var a=t[o];!a||n.ns&&n.ns!==a[_DYN_EVT_NAME].ns||r&&!r(a)||(_doDetach(e,a[_DYN_EVT_NAME],a.handler,a.capture),t[_DYN_SPLICE](o,1))}}function _unregisterEvents(n,r,o){var e;r[_DYN_TYPE]?_doUnregister(n,_getRegisteredEvents(n,r[_DYN_TYPE]),r,o):(objForEachKey(e=elmNodeData.get(n,strEvents,{}),function(e,t){_doUnregister(n,t,r,o)}),0===objKeys(e)[_DYN_LENGTH$2]&&elmNodeData.kill(n,strEvents))}function mergeEvtNamespace(e,t){return t?_getEvtNamespace("xx",isArray(t)?[e].concat(t):[e,t]).ns[_DYN_SPLIT$1]("."):e}function eventOn(e,t,n,r,o){void 0===o&&(o=!1);var a=!1;if(e)try{var i,_=_getEvtNamespace(t,r);(a=_doAttach(e,_,n,o))&&elmNodeData.accept(e)&&(i={guid:_guid++,evtName:_,handler:n,capture:o},_getRegisteredEvents(e,_.type)[_DYN_PUSH$1](i))}catch(s){}return a}function eventOff(e,t,n,r,o){if(void 0===o&&(o=!1),e)try{var a=_getEvtNamespace(t,r),i=!1;_unregisterEvents(e,a,function(e){return!((!a.ns||n)&&e.handler!==n)&&(i=!0)}),i||_doDetach(e,a,n,o)}catch(_){}}var SampleRate="sampleRate",ProcessLegacy="ProcessLegacy",HttpMethod="http.method",DEFAULT_BREEZE_ENDPOINT="https://dc.services.visualstudio.com",DEFAULT_BREEZE_PATH="/v2/track",strNotSpecified="not_specified",RequestHeaders=createValueMap({requestContextHeader:[0,"Request-Context"],requestContextTargetKey:[1,"appId"],requestContextAppIdFormat:[2,"appId=cid-v1:"],requestIdHeader:[3,"Request-Id"],traceParentHeader:[4,"traceparent"],traceStateHeader:[5,"tracestate"],sdkContextHeader:[6,"Sdk-Context"],sdkContextHeaderAppIdRequest:[7,"appId"],requestContextHeaderLowerCase:[8,"request-context"]}),_DYN_SPLIT="split",_DYN_LENGTH$1="length",_DYN_TO_LOWER_CASE="toLowerCase",_DYN_TO_STRING$1="toString",_DYN_REMOVE_ITEM="removeItem",_DYN_MESSAGE="message",_DYN_COUNT$1="count",_DYN_STRINGIFY$1="stringify",_DYN_PATHNAME="pathname",_DYN_MATCH="match",_DYN_NAME$1="name",_DYN_PROPERTIES="properties",_DYN_MEASUREMENTS$1="measurements",_DYN_SIZE_IN_BYTES="sizeInBytes",_DYN_TYPE_NAME="typeName",_DYN_EXCEPTIONS="exceptions",_DYN_SEVERITY_LEVEL="severityLevel",_DYN_PROBLEM_GROUP="problemGroup",_DYN_PARSED_STACK="parsedStack",_DYN_HAS_FULL_STACK="hasFullStack",_DYN_ASSEMBLY="assembly",_DYN_FILE_NAME="fileName",_DYN_LINE="line",_DYN_AI_DATA_CONTRACT="aiDataContract",_DYN_DURATION="duration";function dataSanitizeKeyAndAddUniqueness(e,t,n){var r=t[_DYN_LENGTH$1],o=dataSanitizeKey(e,t);if(o[_DYN_LENGTH$1]!==r){for(var a=0,i=o;n[i]!==undefined;)a++,i=strSubstring(o,0,147)+dsPadNumber(a);o=i}return o}function dataSanitizeKey(e,t){var n;return t&&150<(t=strTrim(asString(t)))[_DYN_LENGTH$1]&&(n=strSubstring(t,0,150),_throwInternal(e,2,57,"name is too long.  It has been truncated to 150 characters.",{name:t},!0)),n||t}function dataSanitizeString(e,t,n){var r;return void 0===n&&(n=1024),t&&(n=n||1024,(t=strTrim(asString(t)))[_DYN_LENGTH$1]>n&&(r=strSubstring(t,0,n),_throwInternal(e,2,61,"string value is too long. It has been truncated to "+n+" characters.",{value:t},!0))),r||t}function dataSanitizeUrl(e,t){return dataSanitizeInput(e,t,2048,66)}function dataSanitizeMessage(e,t){var n;return t&&32768<t[_DYN_LENGTH$1]&&(n=strSubstring(t,0,32768),_throwInternal(e,2,56,"message is too long, it has been truncated to 32768 characters.",{message:t},!0)),n||t}function dataSanitizeException(e,t){var n,r;return t&&32768<(r=""+t)[_DYN_LENGTH$1]&&(n=strSubstring(r,0,32768),_throwInternal(e,2,52,"exception is too long, it has been truncated to 32768 characters.",{exception:t},!0)),n||t}function dataSanitizeProperties(r,e){var o;return e&&(o={},objForEachKey(e,function(e,t){if(isObject(t)&&hasJSON())try{t=getJSON()[_DYN_STRINGIFY$1](t)}catch(n){_throwInternal(r,2,49,"custom property is not valid",{exception:n},!0)}t=dataSanitizeString(r,t,8192),e=dataSanitizeKeyAndAddUniqueness(r,e,o),o[e]=t}),e=o),e}function dataSanitizeMeasurements(n,e){var r;return e&&(r={},objForEachKey(e,function(e,t){e=dataSanitizeKeyAndAddUniqueness(n,e,r),r[e]=t}),e=r),e}function dataSanitizeId(e,t){return t&&dataSanitizeInput(e,t,128,69)[_DYN_TO_STRING$1]()}function dataSanitizeInput(e,t,n,r){var o;return t&&(t=strTrim(asString(t)))[_DYN_LENGTH$1]>n&&(o=strSubstring(t,0,n),_throwInternal(e,2,r,"input is too long, it has been truncated to "+n+" characters.",{data:t},!0)),o||t}function dsPadNumber(e){e="00"+e;return strSubstr(e,e[_DYN_LENGTH$1]-3)}var _document=getDocument()||{},_htmlAnchorIdx=0,_htmlAnchorElement=[null,null,null,null,null];function urlParseUrl(e){var t=_htmlAnchorIdx,n=_htmlAnchorElement,r=n[t];return _document.createElement?n[t]||(r=n[t]=_document.createElement("a")):r={host:urlParseHost(e,!0)},r.href=e,++t>=n[_DYN_LENGTH$1]&&(t=0),_htmlAnchorIdx=t,r}function urlParseHost(e,t){e=urlParseFullHost(e,t)||"";if(e){t=e[_DYN_MATCH](/(www\d{0,5}\.)?([^\/:]{1,256})(:\d{1,20})?/i);if(null!=t&&3<t[_DYN_LENGTH$1]&&isString(t[2])&&0<t[2][_DYN_LENGTH$1])return t[2]+(t[3]||"")}return e}function urlParseFullHost(e,t){var n=null;return e&&null!=(e=e[_DYN_MATCH](/(\w{1,150}):\/\/([^\/:]{1,256})(:\d{1,20})?/i))&&2<e[_DYN_LENGTH$1]&&isString(e[2])&&0<e[2][_DYN_LENGTH$1]&&(n=e[2]||"",t&&2<e[_DYN_LENGTH$1]&&(t=(e[1]||"")[_DYN_TO_LOWER_CASE](),e=e[3]||"",n+=e="http"===t&&":80"===e||"https"===t&&":443"===e?"":e)),n}var _internalEndpoints=[DEFAULT_BREEZE_ENDPOINT+DEFAULT_BREEZE_PATH,"https://breeze.aimon.applicationinsights.io"+DEFAULT_BREEZE_PATH,"https://dc-int.services.visualstudio.com"+DEFAULT_BREEZE_PATH];function isInternalApplicationInsightsEndpoint(e){return-1!==arrIndexOf(_internalEndpoints,e[_DYN_TO_LOWER_CASE]())}function AjaxHelperParseDependencyPath(e,t,n,r){var o,a,i,_=r,s=r,_=t&&0<t[_DYN_LENGTH$1]?(i=(o=urlParseUrl(t)).host,_||(null!=o[_DYN_PATHNAME]?("/"!=((a=0===o.pathname[_DYN_LENGTH$1]?"/":o[_DYN_PATHNAME])[0]||"")&&(a="/"+a),s=o[_DYN_PATHNAME],dataSanitizeString(e,n?n+" "+a:a)):dataSanitizeString(e,t))):i=r;return{target:i,name:_,data:s}}var StorageType=createEnumStyle({LocalStorage:0,SessionStorage:1}),_canUseSessionStorage=undefined,_storagePrefix="";function _getVerifiedStorageObject(e){try{if(isNullOrUndefined(getGlobal()))return null;var t=(new Date)[_DYN_TO_STRING$1](),n=getInst(e===StorageType.LocalStorage?"localStorage":"sessionStorage"),r=_storagePrefix+t,o=(n.setItem(r,t),n.getItem(r)!==t);if(n[_DYN_REMOVE_ITEM](r),!o)return n}catch(a){}return null}function _getSessionStorageObject(){return utlCanUseSessionStorage()?_getVerifiedStorageObject(StorageType.SessionStorage):null}function utlSetStoragePrefix(e){_storagePrefix=e||""}function utlCanUseSessionStorage(e){return _canUseSessionStorage=e||_canUseSessionStorage===undefined?!!_getVerifiedStorageObject(StorageType.SessionStorage):_canUseSessionStorage}function utlGetSessionStorage(e,t){var n=_getSessionStorageObject();if(null!==n)try{return n.getItem(t)}catch(r){_canUseSessionStorage=!1,_throwInternal(e,2,2,"Browser failed read of session storage. "+getExceptionName(r),{exception:dumpObj(r)})}return null}function utlSetSessionStorage(e,t,n){var r=_getSessionStorageObject();if(null!==r)try{return r.setItem(t,n),!0}catch(o){_canUseSessionStorage=!1,_throwInternal(e,2,4,"Browser failed write to session storage. "+getExceptionName(o),{exception:dumpObj(o)})}return!1}function utlRemoveSessionStorage(e,t){var n=_getSessionStorageObject();if(null!==n)try{return n[_DYN_REMOVE_ITEM](t),!0}catch(r){_canUseSessionStorage=!1,_throwInternal(e,2,6,"Browser failed removal of session storage item. "+getExceptionName(r),{exception:dumpObj(r)})}return!1}var Envelope=function(e,t,n){var r=this,o=this;o.ver=1,o.sampleRate=100,o.tags={},o[_DYN_NAME$1]=dataSanitizeString(e,n)||strNotSpecified,o.data=t,o.time=toISOString(new Date),o[_DYN_AI_DATA_CONTRACT]={time:1,iKey:1,name:1,sampleRate:function(){return 100===r.sampleRate?4:1},tags:1,data:1}},Event$1=function(){function e(e,t,n,r){this.aiDataContract={ver:1,name:1,properties:0,measurements:0},this.ver=2,this[_DYN_NAME$1]=dataSanitizeString(e,t)||strNotSpecified,this[_DYN_PROPERTIES]=dataSanitizeProperties(e,n),this[_DYN_MEASUREMENTS$1]=dataSanitizeMeasurements(e,r)}return e.envelopeType="Microsoft.ApplicationInsights.{0}.Event",e.dataType="EventData",e}(),STACKFRAME_BASE_SIZE=58,IS_FRAME=/^\s{0,50}(from\s|at\s|Line\s{1,5}\d{1,10}\s{1,5}of|\w{1,50}@\w{1,80}|[^\(\s\n]+:[0-9\?]+(?::[0-9\?]+)?)/,FULL_STACK_FRAME_1=/^(?:\s{0,50}at)?\s{0,50}([^\@\()\s]+)?\s{0,50}(?:\s|\@|\()\s{0,5}([^\(\s\n\]]+):([0-9\?]+):([0-9\?]+)\)?$/,FULL_STACK_FRAME_2=/^(?:\s{0,50}at)?\s{0,50}([^\@\()\s]+)?\s{0,50}(?:\s|\@|\()\s{0,5}([^\(\s\n\]]+):([0-9\?]+)\)?$/,FULL_STACK_FRAME_3=/^(?:\s{0,50}at)?\s{0,50}([^\@\()\s]+)?\s{0,50}(?:\s|\@|\()\s{0,5}([^\(\s\n\)\]]+)\)?$/,EXTRACT_FILENAME=/(?:^|\(|\s{0,10}[\w\)]+\@)?([^\(\n\s\]\)]+)(?:\:([0-9]+)(?:\:([0-9]+))?)?\)?(?:,|$)/,PARSE_FILENAME_LINE_COL=/([^\(\s\n]+):([0-9]+):([0-9]+)$/,PARSE_FILENAME_LINE_ONLY=/([^\(\s\n]+):([0-9]+)$/,NoMethod="<no_method>",strError="error",strStack="stack",strStackDetails="stackDetails",strErrorSrc="errorSrc",strMessage="message",strDescription="description",_parseSequence=[{re:FULL_STACK_FRAME_1,len:5,m:1,fn:2,ln:3,col:4},{chk:_ignoreNative,pre:_scrubAnonymous,re:FULL_STACK_FRAME_2,len:4,m:1,fn:2,ln:3},{re:FULL_STACK_FRAME_3,len:3,m:1,fn:2,hdl:_handleFilename},{re:EXTRACT_FILENAME,len:2,fn:1,hdl:_handleFilename}];function _scrubAnonymous(e){return e.replace(/(\(anonymous\))/,"<anonymous>")}function _ignoreNative(e){return strIndexOf(e,"[native")<0}function _stringify(e,t){var n=e;return n&&!isString(n)&&(JSON&&JSON[_DYN_STRINGIFY$1]?(n=JSON[_DYN_STRINGIFY$1](e),!t||n&&"{}"!==n||(n=isFunction(e[_DYN_TO_STRING$1])?e[_DYN_TO_STRING$1]():""+e)):n=e+" - (Missing JSON.stringify)"),n||""}function _formatMessage(e,t){var n=e;return e&&((n=n&&!isString(n)&&(e[strMessage]||e[strDescription])||n)&&!isString(n)&&(n=_stringify(n,!0)),e.filename&&(n=n+" @"+(e.filename||"")+":"+(e.lineno||"?")+":"+(e.colno||"?"))),(t&&"String"!==t&&"Object"!==t&&"Error"!==t&&-1===strIndexOf(n||"",t)?t+": "+n:n)||""}function _isExceptionDetailsInternal(e){try{if(isObject(e))return"hasFullStack"in e&&"typeName"in e}catch(t){}return!1}function _isExceptionInternal(e){try{if(isObject(e))return"ver"in e&&"exceptions"in e&&"properties"in e}catch(t){}return!1}function _isStackDetails(e){return e&&e.src&&isString(e.src)&&e.obj&&isArray(e.obj)}function _convertStackObj(e){var e=e||"",t=(e=isString(e)?e:isString(e[strStack])?e[strStack]:""+e)[_DYN_SPLIT]("\n");return{src:e,obj:t}}function _getOperaStack(e){for(var t=[],n=e[_DYN_SPLIT]("\n"),r=0;r<n[_DYN_LENGTH$1];r++){var o=n[r];n[r+1]&&(o+="@"+n[r+1],r++),t.push(o)}return{src:e,obj:t}}function _getStackFromErrorObj(e){var t,n=null;if(e)try{e[strStack]?n=_convertStackObj(e[strStack]):e[strError]&&e[strError][strStack]?n=_convertStackObj(e[strError][strStack]):e.exception&&e.exception[strStack]?n=_convertStackObj(e.exception[strStack]):_isStackDetails(e)?n=e:_isStackDetails(e[strStackDetails])?n=e[strStackDetails]:getWindow()&&getWindow().opera&&e[strMessage]?n=_getOperaStack(e[_DYN_MESSAGE]):e.reason&&e.reason[strStack]?n=_convertStackObj(e.reason[strStack]):isString(e)?n=_convertStackObj(e):(t=e[strMessage]||e[strDescription]||"",isString(e[strErrorSrc])&&(t&&(t+="\n"),t+=" from "+e[strErrorSrc]),t&&(n=_convertStackObj(t)))}catch(r){n=_convertStackObj(r)}return n||{src:"",obj:null}}function _formatStackTrace(e){return e?e.obj?e.obj.join("\n"):e.src||"":""}function _parseStack(e){e=e.obj;if(e&&0<e[_DYN_LENGTH$1]){var t=[],n=0,r=!1,o=0;if(arrForEach(e,function(e){(r||_isStackFrame(e))&&(e=asString(e),r=!0,(e=_extractStackFrame(e,n))&&(o+=e[_DYN_SIZE_IN_BYTES],t.push(e),n++))}),32768<o)for(var a=0,i=t[_DYN_LENGTH$1]-1,_=0,s=a,c=i;a<i;){if(32768<(_+=t[a][_DYN_SIZE_IN_BYTES]+t[i][_DYN_SIZE_IN_BYTES])){t.splice(s,c-s+1);break}s=a,c=i,a++,i--}}return t}function _getErrorType(e){var t="";if(e&&!(t=e.typeName||e[_DYN_NAME$1]||""))try{var n=/function (.{1,200})\(/.exec(e.constructor[_DYN_TO_STRING$1]()),t=n&&1<n[_DYN_LENGTH$1]?n[1]:""}catch(r){}return t}function _formatErrorCode(e){if(e)try{var t,n;if(!isString(e))return t=_getErrorType(e),(n=_stringify(e,!1))&&"{}"!==n||(e[strError]&&(t=_getErrorType(e=e[strError])),n=_stringify(e,!0)),0!==strIndexOf(n,t)&&"String"!==t?t+":"+n:n}catch(r){}return""+(e||"")}var Exception=function(){function a(e,t,n,r,o,a){this.aiDataContract={ver:1,exceptions:1,severityLevel:0,properties:0,measurements:0};var i=this;i.ver=2,_isExceptionInternal(t)?(i[_DYN_EXCEPTIONS]=t[_DYN_EXCEPTIONS]||[],i[_DYN_PROPERTIES]=t[_DYN_PROPERTIES],i[_DYN_MEASUREMENTS$1]=t[_DYN_MEASUREMENTS$1],t[_DYN_SEVERITY_LEVEL]&&(i[_DYN_SEVERITY_LEVEL]=t[_DYN_SEVERITY_LEVEL]),t.id&&(i.id=t.id,t[_DYN_PROPERTIES].id=t.id),t[_DYN_PROBLEM_GROUP]&&(i[_DYN_PROBLEM_GROUP]=t[_DYN_PROBLEM_GROUP]),isNullOrUndefined(t.isManual)||(i.isManual=t.isManual)):(n=n||{},a&&(n.id=a),i[_DYN_EXCEPTIONS]=[_createExceptionDetails(e,t,n)],i[_DYN_PROPERTIES]=dataSanitizeProperties(e,n),i[_DYN_MEASUREMENTS$1]=dataSanitizeMeasurements(e,r),o&&(i[_DYN_SEVERITY_LEVEL]=o),a&&(i.id=a))}return a.CreateAutoException=function(e,t,n,r,o,a,i,_){var s=_getErrorType(o||a||e);return{message:_formatMessage(e,s),url:t,lineNumber:n,columnNumber:r,error:_formatErrorCode(o||a||e),evt:_formatErrorCode(a||e),typeName:s,stackDetails:_getStackFromErrorObj(i||o||a),errorSrc:_}},a.CreateFromInterface=function(t,e,n,r){var o=e[_DYN_EXCEPTIONS]&&arrMap(e[_DYN_EXCEPTIONS],function(e){return _createExDetailsFromInterface(t,e)});return new a(t,__assignFn(__assignFn({},e),{exceptions:o}),n,r)},a.prototype.toInterface=function(){var e=this,t=e.exceptions,n=e.properties,r=e.measurements,o=e.severityLevel,a=e.problemGroup,i=e.id,e=e.isManual;return{ver:"4.0",exceptions:t instanceof Array&&arrMap(t,function(e){return e.toInterface()})||undefined,severityLevel:o,properties:n,measurements:r,problemGroup:a,id:i,isManual:e}},a.CreateSimpleException=function(e,t,n,r,o,a){var i;return{exceptions:[((i={})[_DYN_HAS_FULL_STACK]=!0,i.message=e,i.stack=o,i.typeName=t,i)]}},a.envelopeType="Microsoft.ApplicationInsights.{0}.Exception",a.dataType="ExceptionData",a.formatError=_formatErrorCode,a}(),exDetailsAiDataContract=objFreeze({id:0,outerId:0,typeName:1,message:1,hasFullStack:0,stack:0,parsedStack:2});function _toInterface(){var e=this,t=isArray(e[_DYN_PARSED_STACK])&&arrMap(e[_DYN_PARSED_STACK],function(e){return _parsedFrameToInterface(e)});return{id:e.id,outerId:e.outerId,typeName:e[_DYN_TYPE_NAME],message:e[_DYN_MESSAGE],hasFullStack:e[_DYN_HAS_FULL_STACK],stack:e[strStack],parsedStack:t||undefined}}function _createExceptionDetails(t,e,n){var r,o,a,i,_,s,c;return _isExceptionDetailsInternal(e)?(r=e[_DYN_TYPE_NAME],o=e[_DYN_MESSAGE],i=e[strStack],c=e[_DYN_PARSED_STACK]||[],a=e[_DYN_HAS_FULL_STACK]):(s=(_=e)&&_.evt,isError(_)||(_=_[strError]||s||_),r=dataSanitizeString(t,_getErrorType(_))||strNotSpecified,o=dataSanitizeMessage(t,_formatMessage(e||_,r))||strNotSpecified,c=_parseStack(s=e[strStackDetails]||_getStackFromErrorObj(e)),isArray(c)&&arrMap(c,function(e){e[_DYN_ASSEMBLY]=dataSanitizeString(t,e[_DYN_ASSEMBLY]),e[_DYN_FILE_NAME]=dataSanitizeString(t,e[_DYN_FILE_NAME])}),i=dataSanitizeException(t,_formatStackTrace(s)),a=isArray(c)&&0<c[_DYN_LENGTH$1],n&&(n[_DYN_TYPE_NAME]=n[_DYN_TYPE_NAME]||r)),(_={})[_DYN_AI_DATA_CONTRACT]=exDetailsAiDataContract,_.id=void 0,_.outerId=void 0,_.typeName=r,_.message=o,_[_DYN_HAS_FULL_STACK]=a,_.stack=i,_.parsedStack=c,_.toInterface=_toInterface,_}function _createExDetailsFromInterface(e,t){var n=isArray(t[_DYN_PARSED_STACK])&&arrMap(t[_DYN_PARSED_STACK],function(e){return _stackFrameFromInterface(e)})||t[_DYN_PARSED_STACK];return _createExceptionDetails(e,__assignFn(__assignFn({},t),{parsedStack:n}))}function _parseFilename(e,t){var n=t[_DYN_MATCH](PARSE_FILENAME_LINE_COL);n&&4<=n[_DYN_LENGTH$1]?(e[_DYN_FILE_NAME]=n[1],e[_DYN_LINE]=parseInt(n[2])):(n=t[_DYN_MATCH](PARSE_FILENAME_LINE_ONLY))&&3<=n[_DYN_LENGTH$1]?(e[_DYN_FILE_NAME]=n[1],e[_DYN_LINE]=parseInt(n[2])):e[_DYN_FILE_NAME]=t}function _handleFilename(e,t,n){var r=e[_DYN_FILE_NAME];t.fn&&n&&n[_DYN_LENGTH$1]>t.fn&&(t.ln&&n[_DYN_LENGTH$1]>t.ln?(r=strTrim(n[t.fn]||""),e[_DYN_LINE]=parseInt(strTrim(n[t.ln]||""))||0):r=strTrim(n[t.fn]||"")),r&&_parseFilename(e,r)}function _isStackFrame(e){var t=!1;return e&&isString(e)&&(e=strTrim(e))?IS_FRAME.test(e):t}var stackFrameAiDataContract=objFreeze({level:1,method:1,assembly:0,fileName:0,line:0});function _extractStackFrame(e,t){var n;if(e&&isString(e)&&strTrim(e)){(n={})[_DYN_AI_DATA_CONTRACT]=stackFrameAiDataContract,n.level=t,n.assembly=strTrim(e),n.method=NoMethod,n.fileName="",n.line=0,n.sizeInBytes=0;for(var r=n,o=0;o<_parseSequence[_DYN_LENGTH$1];){var a=_parseSequence[o];if(a.chk&&!a.chk(e))break;var i=(e=a.pre?a.pre(e):e)[_DYN_MATCH](a.re);if(i&&i[_DYN_LENGTH$1]>=a.len){a.m&&(r.method=strTrim(i[a.m]||NoMethod)),a.hdl?a.hdl(r,a,i):a.fn&&(a.ln?(r[_DYN_FILE_NAME]=strTrim(i[a.fn]||""),r[_DYN_LINE]=parseInt(strTrim(i[a.ln]||""))||0):_parseFilename(r,i[a.fn]||""));break}o++}}return _populateFrameSizeInBytes(r)}function _stackFrameFromInterface(e){var t;return(t={})[_DYN_AI_DATA_CONTRACT]=stackFrameAiDataContract,t.level=e.level,t.method=e.method,t.assembly=e[_DYN_ASSEMBLY],t.fileName=e[_DYN_FILE_NAME],t.line=e[_DYN_LINE],t.sizeInBytes=0,_populateFrameSizeInBytes(t)}function _populateFrameSizeInBytes(e){var t=STACKFRAME_BASE_SIZE;return e&&(t=(t+=e.method[_DYN_LENGTH$1])+e.assembly[_DYN_LENGTH$1]+e.fileName[_DYN_LENGTH$1]+e.level.toString()[_DYN_LENGTH$1]+e.line.toString()[_DYN_LENGTH$1],e[_DYN_SIZE_IN_BYTES]=t),e}function _parsedFrameToInterface(e){return{level:e.level,method:e.method,assembly:e[_DYN_ASSEMBLY],fileName:e[_DYN_FILE_NAME],line:e[_DYN_LINE]}}var DataPoint=function(){this.aiDataContract={name:1,kind:0,value:1,count:0,min:0,max:0,stdDev:0},this.kind=0},Metric=function(){function e(e,t,n,r,o,a,i,_,s){this.aiDataContract={ver:1,metrics:1,properties:0},this.ver=2;var c=new DataPoint;c[_DYN_COUNT$1]=0<r?r:undefined,c.max=isNaN(a)||null===a?undefined:a,c.min=isNaN(o)||null===o?undefined:o,c[_DYN_NAME$1]=dataSanitizeString(e,t)||strNotSpecified,c.value=n,c.stdDev=isNaN(i)||null===i?undefined:i,this.metrics=[c],this[_DYN_PROPERTIES]=dataSanitizeProperties(e,_),this[_DYN_MEASUREMENTS$1]=dataSanitizeMeasurements(e,s)}return e.envelopeType="Microsoft.ApplicationInsights.{0}.Metric",e.dataType="MetricData",e}(),strEmpty="";function msToTimeSpan(e){e=mathRound(e=isNaN(e)||e<0?0:e);var t=strEmpty+e%1e3,n=strEmpty+mathFloor(e/1e3)%60,r=strEmpty+mathFloor(e/6e4)%60,o=strEmpty+mathFloor(e/36e5)%24,e=mathFloor(e/864e5),t=1===t[_DYN_LENGTH$1]?"00"+t:2===t[_DYN_LENGTH$1]?"0"+t:t,n=n[_DYN_LENGTH$1]<2?"0"+n:n,r=r[_DYN_LENGTH$1]<2?"0"+r:r,o=o[_DYN_LENGTH$1]<2?"0"+o:o;return(0<e?e+".":strEmpty)+o+":"+r+":"+n+"."+t}var PageView=function(){function e(e,t,n,r,o,a,i){this.aiDataContract={ver:1,name:0,url:0,duration:0,properties:0,measurements:0,id:0};var _=this;_.ver=2,_.id=dataSanitizeId(e,i),_.url=dataSanitizeUrl(e,n),_[_DYN_NAME$1]=dataSanitizeString(e,t)||strNotSpecified,isNaN(r)||(_[_DYN_DURATION]=msToTimeSpan(r)),_[_DYN_PROPERTIES]=dataSanitizeProperties(e,o),_[_DYN_MEASUREMENTS$1]=dataSanitizeMeasurements(e,a)}return e.envelopeType="Microsoft.ApplicationInsights.{0}.Pageview",e.dataType="PageviewData",e}(),RemoteDependencyData=function(){function e(e,t,n,r,o,a,i,_,s,c,u,l){void 0===s&&(s="Ajax"),this.aiDataContract={id:1,ver:1,name:0,resultCode:0,duration:0,success:0,data:0,target:0,type:0,properties:0,measurements:0,kind:0,value:0,count:0,min:0,max:0,stdDev:0,dependencyKind:0,dependencySource:0,commandName:0,dependencyTypeName:0};var N=this,t=(N.ver=2,N.id=t,N[_DYN_DURATION]=msToTimeSpan(o),N.success=a,N.resultCode=i+"",N.type=dataSanitizeString(e,s),AjaxHelperParseDependencyPath(e,n,_,r));N.data=dataSanitizeUrl(e,r)||t.data,N.target=dataSanitizeString(e,t.target),c&&(N.target="".concat(N.target," | ").concat(c)),N[_DYN_NAME$1]=dataSanitizeString(e,t[_DYN_NAME$1]),N[_DYN_PROPERTIES]=dataSanitizeProperties(e,u),N[_DYN_MEASUREMENTS$1]=dataSanitizeMeasurements(e,l)}return e.envelopeType="Microsoft.ApplicationInsights.{0}.RemoteDependency",e.dataType="RemoteDependencyData",e}(),Trace=function(){function e(e,t,n,r,o){this.aiDataContract={ver:1,message:1,severityLevel:0,properties:0};var a=this;a.ver=2,a[_DYN_MESSAGE]=dataSanitizeMessage(e,t=t||strNotSpecified),a[_DYN_PROPERTIES]=dataSanitizeProperties(e,r),a[_DYN_MEASUREMENTS$1]=dataSanitizeMeasurements(e,o),n&&(a[_DYN_SEVERITY_LEVEL]=n)}return e.envelopeType="Microsoft.ApplicationInsights.{0}.Message",e.dataType="MessageData",e}(),PageViewPerformance=function(){function e(e,t,n,r,o,a,i){this.aiDataContract={ver:1,name:0,url:0,duration:0,perfTotal:0,networkConnect:0,sentRequest:0,receivedResponse:0,domProcessing:0,properties:0,measurements:0};var _=this;_.ver=2,_.url=dataSanitizeUrl(e,n),_[_DYN_NAME$1]=dataSanitizeString(e,t)||strNotSpecified,_[_DYN_PROPERTIES]=dataSanitizeProperties(e,o),_[_DYN_MEASUREMENTS$1]=dataSanitizeMeasurements(e,a),i&&(_.domProcessing=i.domProcessing,_[_DYN_DURATION]=i[_DYN_DURATION],_.networkConnect=i.networkConnect,_.perfTotal=i.perfTotal,_.receivedResponse=i.receivedResponse,_.sentRequest=i.sentRequest)}return e.envelopeType="Microsoft.ApplicationInsights.{0}.PageviewPerformance",e.dataType="PageviewPerformanceData",e}(),Data=function(e,t){this.aiDataContract={baseType:1,baseData:1},this.baseType=e,this.baseData=t};function _aiNameFunc(e){var t="ai."+e+".";return function(e){return t+e}}var _aiApplication=_aiNameFunc("application"),_aiDevice=_aiNameFunc("device"),_aiLocation=_aiNameFunc("location"),_aiOperation=_aiNameFunc("operation"),_aiSession=_aiNameFunc("session"),_aiUser=_aiNameFunc("user"),_aiCloud=_aiNameFunc("cloud"),_aiInternal=_aiNameFunc("internal"),ContextTagKeys=function(e){function t(){return e.call(this)||this}return __extendsFn(t,e),t}(createClassFromInterface({applicationVersion:_aiApplication("ver"),applicationBuild:_aiApplication("build"),applicationTypeId:_aiApplication("typeId"),applicationId:_aiApplication("applicationId"),applicationLayer:_aiApplication("layer"),deviceId:_aiDevice("id"),deviceIp:_aiDevice("ip"),deviceLanguage:_aiDevice("language"),deviceLocale:_aiDevice("locale"),deviceModel:_aiDevice("model"),deviceFriendlyName:_aiDevice("friendlyName"),deviceNetwork:_aiDevice("network"),deviceNetworkName:_aiDevice("networkName"),deviceOEMName:_aiDevice("oemName"),deviceOS:_aiDevice("os"),deviceOSVersion:_aiDevice("osVersion"),deviceRoleInstance:_aiDevice("roleInstance"),deviceRoleName:_aiDevice("roleName"),deviceScreenResolution:_aiDevice("screenResolution"),deviceType:_aiDevice("type"),deviceMachineName:_aiDevice("machineName"),deviceVMName:_aiDevice("vmName"),deviceBrowser:_aiDevice("browser"),deviceBrowserVersion:_aiDevice("browserVersion"),locationIp:_aiLocation("ip"),locationCountry:_aiLocation("country"),locationProvince:_aiLocation("province"),locationCity:_aiLocation("city"),operationId:_aiOperation("id"),operationName:_aiOperation("name"),operationParentId:_aiOperation("parentId"),operationRootId:_aiOperation("rootId"),operationSyntheticSource:_aiOperation("syntheticSource"),operationCorrelationVector:_aiOperation("correlationVector"),sessionId:_aiSession("id"),sessionIsFirst:_aiSession("isFirst"),sessionIsNew:_aiSession("isNew"),userAccountAcquisitionDate:_aiUser("accountAcquisitionDate"),userAccountId:_aiUser("accountId"),userAgent:_aiUser("userAgent"),userId:_aiUser("id"),userStoreRegion:_aiUser("storeRegion"),userAuthUserId:_aiUser("authUserId"),userAnonymousUserAcquisitionDate:_aiUser("anonUserAcquisitionDate"),userAuthenticatedUserAcquisitionDate:_aiUser("authUserAcquisitionDate"),cloudName:_aiCloud("name"),cloudRole:_aiCloud("role"),cloudRoleVer:_aiCloud("roleVer"),cloudRoleInstance:_aiCloud("roleInstance"),cloudEnvironment:_aiCloud("environment"),cloudLocation:_aiCloud("location"),cloudDeploymentUnit:_aiCloud("deploymentUnit"),internalNodeName:_aiInternal("nodeName"),internalSdkVersion:_aiInternal("sdkVersion"),internalAgentVersion:_aiInternal("agentVersion"),internalSnippet:_aiInternal("snippet"),internalSdkSrc:_aiInternal("sdkSrc")})),CtxTagKeys=new ContextTagKeys;function _disableEvents(e,t){eventOff(e,null,null,t)}function createOfflineListener(e){var t,n=getDocument(),r=getNavigator(),o=!1,a=[],i=1,_=(!r||isNullOrUndefined(r.onLine)||r.onLine||(i=2),0),s=l(),c=mergeEvtNamespace(createUniqueNamespace("OfflineListener"),e);try{u(getWindow())&&(o=!0),n&&(t=n.body||n).ononline&&u(t)&&(o=!0)}catch(D){o=!1}function u(e){var t=!1;return e&&(t=eventOn(e,"online",E,c))&&eventOn(e,"offline",f,c),t}function l(){return 2!==_&&2!==i}function N(){var e=l();s!==e&&(s=e,arrForEach(a,function(e){var t={isOnline:s,rState:i,uState:_};try{e(t)}catch(D){}}))}function E(){i=1,N()}function f(){i=2,N()}return{isOnline:function(){return s},isListening:function(){return o},unload:function(){var e=getWindow();e&&o&&(_disableEvents(e,c),n&&!isUndefined((e=n.body||n).ononline)&&_disableEvents(e,c),o=!1)},addListener:function(t){return a.push(t),{rm:function(){var e=a.indexOf(t);if(-1<e)return a.splice(e,1)}}},setOnlineState:function(e){_=e,N()}}}var BreezeChannelIdentifier="AppInsightsChannelPlugin",STR_DURATION="duration",_DYN_TAGS="tags",_DYN_DEVICE_TYPE="deviceType",_DYN_DATA="data",_DYN_NAME="name",_DYN_TRACE_ID="traceID",_DYN_LENGTH="length",_DYN_STRINGIFY="stringify",_DYN_MEASUREMENTS="measurements",_DYN_DATA_TYPE="dataType",_DYN_ENVELOPE_TYPE="envelopeType",_DYN_TO_STRING="toString",_DYN_ENQUEUE="enqueue",_DYN_COUNT="count",_DYN_PUSH="push",_DYN_EMIT_LINE_DELIMITED_0="emitLineDelimitedJson",_DYN_CLEAR="clear",_DYN_MARK_AS_SENT="markAsSent",_DYN_CLEAR_SENT="clearSent",_DYN_BUFFER_OVERRIDE="bufferOverride",_DYN__BUFFER__KEY="BUFFER_KEY",_DYN__SENT__BUFFER__KEY="SENT_BUFFER_KEY",_DYN_CONCAT="concat",_DYN__MAX__BUFFER__SIZE="MAX_BUFFER_SIZE",_DYN_TRIGGER_SEND="triggerSend",_DYN_DIAG_LOG="diagLog",_DYN_INITIALIZE="initialize",_DYN__SENDER="_sender",_DYN_ENDPOINT_URL="endpointUrl",_DYN_INSTRUMENTATION_KEY="instrumentationKey",_DYN_CUSTOM_HEADERS="customHeaders",_DYN_MAX_BATCH_SIZE_IN_BY1="maxBatchSizeInBytes",_DYN_ONUNLOAD_DISABLE_BEA2="onunloadDisableBeacon",_DYN_IS_BEACON_API_DISABL3="isBeaconApiDisabled",_DYN_ALWAYS_USE_XHR_OVERR4="alwaysUseXhrOverride",_DYN_ENABLE_SESSION_STORA5="enableSessionStorageBuffer",_DYN__BUFFER="_buffer",_DYN_ONUNLOAD_DISABLE_FET6="onunloadDisableFetch",_DYN_DISABLE_SEND_BEACON_7="disableSendBeaconSplit",_DYN_GET_SENDER_INST="getSenderInst",_DYN__ON_ERROR="_onError",_DYN__ON_PARTIAL_SUCCESS="_onPartialSuccess",_DYN__ON_SUCCESS="_onSuccess",_DYN_ITEMS_RECEIVED="itemsReceived",_DYN_ITEMS_ACCEPTED="itemsAccepted",_DYN_BASE_TYPE="baseType",_DYN_SAMPLE_RATE="sampleRate",_DYN_GET_HASH_CODE_SCORE="getHashCodeScore",strBaseType="baseType",strBaseData="baseData",strProperties="properties",strTrue="true";function _setValueIf(e,t,n){return setValue(e,t,n,isTruthy)}function _extractPartAExtensions(e,t,n){for(var r=n[_DYN_TAGS]=n[_DYN_TAGS]||{},o=t.ext=t.ext||{},a=t[_DYN_TAGS]=t[_DYN_TAGS]||[],i=o.user,i=(i&&(_setValueIf(r,CtxTagKeys.userAuthUserId,i.authId),_setValueIf(r,CtxTagKeys.userId,i.id||i.localId)),o.app),i=(i&&_setValueIf(r,CtxTagKeys.sessionId,i.sesId),o.device),i=(i&&(_setValueIf(r,CtxTagKeys.deviceId,i.id||i.localId),_setValueIf(r,CtxTagKeys[_DYN_DEVICE_TYPE],i.deviceClass),_setValueIf(r,CtxTagKeys.deviceIp,i.ip),_setValueIf(r,CtxTagKeys.deviceModel,i.model),_setValueIf(r,CtxTagKeys[_DYN_DEVICE_TYPE],i[_DYN_DEVICE_TYPE])),t.ext.web),t=(i&&(_setValueIf(r,CtxTagKeys.deviceLanguage,i.browserLang),_setValueIf(r,CtxTagKeys.deviceBrowserVersion,i.browserVer),_setValueIf(r,CtxTagKeys.deviceBrowser,i.browser),_setValueIf(t=(t=(t=n[_DYN_DATA]=n[_DYN_DATA]||{})[strBaseData]=t[strBaseData]||{})[strProperties]=t[strProperties]||{},"domain",i.domain),_setValueIf(t,"isManual",i.isManual?strTrue:null),_setValueIf(t,"screenRes",i.screenRes),_setValueIf(t,"userConsent",i.userConsent?strTrue:null)),o.os),i=(t&&(_setValueIf(r,CtxTagKeys.deviceOS,t[_DYN_NAME]),_setValueIf(r,CtxTagKeys.deviceOSVersion,t.osVer)),o.trace),_=(i&&(_setValueIf(r,CtxTagKeys.operationParentId,i.parentID),_setValueIf(r,CtxTagKeys.operationName,dataSanitizeString(e,i[_DYN_NAME])),_setValueIf(r,CtxTagKeys.operationId,i[_DYN_TRACE_ID])),{}),s=a[_DYN_LENGTH]-1;0<=s;s--)objForEachKey(a[s],function(e,t){_[e]=t}),a.splice(s,1);objForEachKey(a,function(e,t){_[e]=t});t=__assignFn(__assignFn({},r),_);t[CtxTagKeys.internalSdkVersion]||(t[CtxTagKeys.internalSdkVersion]=dataSanitizeString(e,"javascript:".concat(EnvelopeCreator.Version),64)),n[_DYN_TAGS]=optimizeObject(t)}function _extractPropsAndMeasurements(e,n,r){isNullOrUndefined(e)||objForEachKey(e,function(e,t){isNumber(t)?r[e]=t:isString(t)?n[e]=t:hasJSON()&&(n[e]=getJSON()[_DYN_STRINGIFY](t))})}function _convertPropsUndefinedToCustomDefinedValue(n,r){isNullOrUndefined(n)||objForEachKey(n,function(e,t){n[e]=t||r})}function _createEnvelope(e,t,n,r){r=new Envelope(e,r,t),_setValueIf(r,"sampleRate",n[SampleRate]),(n[strBaseData]||{}).startTime&&(r.time=toISOString(n[strBaseData].startTime)),r.iKey=n.iKey,t=n.iKey.replace(/-/g,"");return r[_DYN_NAME]=r[_DYN_NAME].replace("{0}",t),_extractPartAExtensions(e,n,r),n[_DYN_TAGS]=n[_DYN_TAGS]||[],optimizeObject(r)}function EnvelopeCreatorInit(e,t){isNullOrUndefined(t[strBaseData])&&_throwInternal(e,1,46,"telemetryItem.baseData cannot be null.")}var EnvelopeCreator={Version:"3.3.7"};function DependencyEnvelopeCreator(e,t,n){EnvelopeCreatorInit(e,t);var r=t[strBaseData][_DYN_MEASUREMENTS]||{},o=t[strBaseData][strProperties]||{},n=(_extractPropsAndMeasurements(t[_DYN_DATA],o,r),isNullOrUndefined(n)||_convertPropsUndefinedToCustomDefinedValue(o,n),t[strBaseData]);if(isNullOrUndefined(n))return _warnToConsole(e,"Invalid input for dependency data"),null;var a=n[strProperties]&&n[strProperties][HttpMethod]?n[strProperties][HttpMethod]:"GET",a=new RemoteDependencyData(e,n.id,n.target,n[_DYN_NAME],n[STR_DURATION],n.success,n.responseCode,a,n.type,n.correlationContext,o,r),n=new Data(RemoteDependencyData[_DYN_DATA_TYPE],a);return _createEnvelope(e,RemoteDependencyData[_DYN_ENVELOPE_TYPE],t,n)}function EventEnvelopeCreator(e,t,n){EnvelopeCreatorInit(e,t);var r={},o={},n=(t[strBaseType]!==Event$1[_DYN_DATA_TYPE]&&(r.baseTypeSource=t[strBaseType]),t[strBaseType]===Event$1[_DYN_DATA_TYPE]?(r=t[strBaseData][strProperties]||{},o=t[strBaseData][_DYN_MEASUREMENTS]||{}):t[strBaseData]&&_extractPropsAndMeasurements(t[strBaseData],r,o),_extractPropsAndMeasurements(t[_DYN_DATA],r,o),isNullOrUndefined(n)||_convertPropsUndefinedToCustomDefinedValue(r,n),t[strBaseData][_DYN_NAME]),n=new Event$1(e,n,r,o),r=new Data(Event$1[_DYN_DATA_TYPE],n);return _createEnvelope(e,Event$1[_DYN_ENVELOPE_TYPE],t,r)}function ExceptionEnvelopeCreator(e,t,n){EnvelopeCreatorInit(e,t);var r=t[strBaseData][_DYN_MEASUREMENTS]||{},o=t[strBaseData][strProperties]||{},n=(_extractPropsAndMeasurements(t[_DYN_DATA],o,r),isNullOrUndefined(n)||_convertPropsUndefinedToCustomDefinedValue(o,n),t[strBaseData]),n=Exception.CreateFromInterface(e,n,o,r),o=new Data(Exception[_DYN_DATA_TYPE],n);return _createEnvelope(e,Exception[_DYN_ENVELOPE_TYPE],t,o)}function MetricEnvelopeCreator(e,t,n){EnvelopeCreatorInit(e,t);var r=t[strBaseData],o=r[strProperties]||{},a=r[_DYN_MEASUREMENTS]||{},n=(_extractPropsAndMeasurements(t[_DYN_DATA],o,a),isNullOrUndefined(n)||_convertPropsUndefinedToCustomDefinedValue(o,n),new Metric(e,r[_DYN_NAME],r.average,r.sampleCount,r.min,r.max,r.stdDev,o,a)),r=new Data(Metric[_DYN_DATA_TYPE],n);return _createEnvelope(e,Metric[_DYN_ENVELOPE_TYPE],t,r)}function PageViewEnvelopeCreator(e,t,n){EnvelopeCreatorInit(e,t);var r,o=t[strBaseData],o=(isNullOrUndefined(o)||isNullOrUndefined(o[strProperties])||isNullOrUndefined(o[strProperties][STR_DURATION])?isNullOrUndefined(t[_DYN_DATA])||isNullOrUndefined(t[_DYN_DATA][STR_DURATION])||(r=t[_DYN_DATA][STR_DURATION],delete t[_DYN_DATA][STR_DURATION]):(r=o[strProperties][STR_DURATION],delete o[strProperties][STR_DURATION]),t[strBaseData]),a=(((t.ext||{}).trace||{})[_DYN_TRACE_ID]&&(a=t.ext.trace[_DYN_TRACE_ID]),o.id||a),i=o[_DYN_NAME],_=o.uri,s=o[strProperties]||{},c=o[_DYN_MEASUREMENTS]||{},o=(isNullOrUndefined(o.refUri)||(s.refUri=o.refUri),isNullOrUndefined(o.pageType)||(s.pageType=o.pageType),isNullOrUndefined(o.isLoggedIn)||(s.isLoggedIn=o.isLoggedIn[_DYN_TO_STRING]()),isNullOrUndefined(o[strProperties])||objForEachKey(o[strProperties],function(e,t){s[e]=t}),_extractPropsAndMeasurements(t[_DYN_DATA],s,c),isNullOrUndefined(n)||_convertPropsUndefinedToCustomDefinedValue(s,n),new PageView(e,i,_,r,s,c,a)),n=new Data(PageView[_DYN_DATA_TYPE],o);return _createEnvelope(e,PageView[_DYN_ENVELOPE_TYPE],t,n)}function PageViewPerformanceEnvelopeCreator(e,t,n){EnvelopeCreatorInit(e,t);var r=t[strBaseData],o=r[_DYN_NAME],a=r.uri||r.url,i=r[strProperties]||{},_=r[_DYN_MEASUREMENTS]||{},n=(_extractPropsAndMeasurements(t[_DYN_DATA],i,_),isNullOrUndefined(n)||_convertPropsUndefinedToCustomDefinedValue(i,n),new PageViewPerformance(e,o,a,undefined,i,_,r)),o=new Data(PageViewPerformance[_DYN_DATA_TYPE],n);return _createEnvelope(e,PageViewPerformance[_DYN_ENVELOPE_TYPE],t,o)}function TraceEnvelopeCreator(e,t,n){EnvelopeCreatorInit(e,t);var r=t[strBaseData].message,o=t[strBaseData].severityLevel,a=t[strBaseData][strProperties]||{},i=t[strBaseData][_DYN_MEASUREMENTS]||{},n=(_extractPropsAndMeasurements(t[_DYN_DATA],a,i),isNullOrUndefined(n)||_convertPropsUndefinedToCustomDefinedValue(a,n),new Trace(e,r,o,a,i)),r=new Data(Trace[_DYN_DATA_TYPE],n);return _createEnvelope(e,Trace[_DYN_ENVELOPE_TYPE],t,r)}var _a,_b,BaseSendBuffer=function(){function e(a,n){var i=[],r=!1,o=n.maxRetryCnt;this._get=function(){return i},this._set=function(e){return i=e},dynamicProto(e,this,function(t){t[_DYN_ENQUEUE]=function(e){t[_DYN_COUNT]()>=n.eventsLimitInMem?r||(_throwInternal(a,2,105,"Maximum in-memory buffer size reached: "+t[_DYN_COUNT](),!0),r=!0):(e.cnt=e.cnt||0,!isNullOrUndefined(o)&&e.cnt>o||i[_DYN_PUSH](e))},t[_DYN_COUNT]=function(){return i[_DYN_LENGTH]},t.size=function(){for(var e=i[_DYN_LENGTH],t=0;t<i[_DYN_LENGTH];t++)e+=i[t].item[_DYN_LENGTH];return n[_DYN_EMIT_LINE_DELIMITED_0]||(e+=2),e},t[_DYN_CLEAR]=function(){r=!(i=[])},t.getItems=function(){return i.slice(0)},t.batchPayloads=function(e){var t;return e&&0<e[_DYN_LENGTH]?(t=[],arrForEach(e,function(e){t[_DYN_PUSH](e.item)}),n[_DYN_EMIT_LINE_DELIMITED_0]?t.join("\n"):"["+t.join(",")+"]"):null},t.createNew=function(e,t,n){var r=i.slice(0),o=new(n?SessionStorageSendBuffer:ArraySendBuffer)(e=e||a,t=t||{});return arrForEach(r,function(e){o[_DYN_ENQUEUE](e)}),o}})}return e.__ieDyn=1,e}(),ArraySendBuffer=function(n){function r(e,t){e=n.call(this,e,t)||this;return dynamicProto(r,e,function(e,t){e[_DYN_MARK_AS_SENT]=function(e){t[_DYN_CLEAR]()},e[_DYN_CLEAR_SENT]=function(e){}}),e}return __extendsFn(r,n),r.__ieDyn=1,r}(BaseSendBuffer),PREVIOUS_KEYS=["AI_buffer","AI_sentBuffer"],SessionStorageSendBuffer=function(r){function d(u,e){var t=r.call(this,u,e)||this,l=!1,N=null==e?void 0:e.namePrefix,n=e[_DYN_BUFFER_OVERRIDE]||{getItem:utlGetSessionStorage,setItem:utlSetSessionStorage},E=n.getItem,f=n.setItem,D=e.maxRetryCnt;return dynamicProto(d,t,function(i,t){var e=_(d[_DYN__BUFFER__KEY]),n=_(d[_DYN__SENT__BUFFER__KEY]),r=function(){var n=[];try{return arrForEach(PREVIOUS_KEYS,function(e){var t=c(e);n=n[_DYN_CONCAT](t),N&&(t=c(N+"_"+e),n=n[_DYN_CONCAT](t))}),n}catch(e){_throwInternal(u,2,41,"Transfer events from previous buffers: "+getExceptionName(e)+". previous Buffer items can not be removed",{exception:dumpObj(e)})}return[]}(),r=n[_DYN_CONCAT](r),n=i._set(e[_DYN_CONCAT](r));function o(e,t){var n=[],r=[];return arrForEach(e,function(e){r[_DYN_PUSH](e.item)}),arrForEach(t,function(e){isFunction(e)||-1!==arrIndexOf(r,e.item)||n[_DYN_PUSH](e)}),n}function _(e){return a(N?N+"_"+e:e)}function a(e){try{var t=E(u,e);if(t){var n=getJSON().parse(t);if((n=isString(n)?getJSON().parse(n):n)&&isArray(n))return n}}catch(r){_throwInternal(u,1,42," storage key: "+e+", "+getExceptionName(r),{exception:dumpObj(r)})}return[]}function s(e,t){try{var e=N?N+"_"+e:e,n=JSON[_DYN_STRINGIFY](t);f(u,e,n)}catch(r){f(u,e,JSON[_DYN_STRINGIFY]([])),_throwInternal(u,2,41," storage key: "+e+", "+getExceptionName(r)+". Buffer cleared",{exception:dumpObj(r)})}}function c(e){try{var t=a(e),n=[];return arrForEach(t,function(e){n[_DYN_PUSH]({item:e,cnt:0})}),utlRemoveSessionStorage(u,e),n}catch(r){}return[]}n[_DYN_LENGTH]>d[_DYN__MAX__BUFFER__SIZE]&&(n[_DYN_LENGTH]=d[_DYN__MAX__BUFFER__SIZE]),s(d[_DYN__SENT__BUFFER__KEY],[]),s(d[_DYN__BUFFER__KEY],n),i[_DYN_ENQUEUE]=function(e){i[_DYN_COUNT]()>=d[_DYN__MAX__BUFFER__SIZE]?l||(_throwInternal(u,2,67,"Maximum buffer size reached: "+i[_DYN_COUNT](),!0),l=!0):(e.cnt=e.cnt||0,!isNullOrUndefined(D)&&e.cnt>D||(t[_DYN_ENQUEUE](e),s(d[_DYN__BUFFER__KEY],i._get())))},i[_DYN_CLEAR]=function(){t[_DYN_CLEAR](),s(d[_DYN__BUFFER__KEY],i._get()),s(d[_DYN__SENT__BUFFER__KEY],[]),l=!1},i[_DYN_MARK_AS_SENT]=function(e){s(d[_DYN__BUFFER__KEY],i._set(o(e,i._get())));var t=_(d[_DYN__SENT__BUFFER__KEY]);t instanceof Array&&e instanceof Array&&((t=t[_DYN_CONCAT](e))[_DYN_LENGTH]>d[_DYN__MAX__BUFFER__SIZE]&&(_throwInternal(u,1,67,"Sent buffer reached its maximum size: "+t[_DYN_LENGTH],!0),t[_DYN_LENGTH]=d[_DYN__MAX__BUFFER__SIZE]),s(d[_DYN__SENT__BUFFER__KEY],t))},i[_DYN_CLEAR_SENT]=function(e){e=o(e,_(d[_DYN__SENT__BUFFER__KEY]));s(d[_DYN__SENT__BUFFER__KEY],e)},i.createNew=function(e,t,n){n=!!n;var r=i._get().slice(0),o=_(d[_DYN__SENT__BUFFER__KEY]).slice(0),a=(e=e||u,t=t||{},i[_DYN_CLEAR](),new(n?d:ArraySendBuffer)(e,t));return arrForEach(r,function(e){a[_DYN_ENQUEUE](e)}),n&&a[_DYN_MARK_AS_SENT](o),a}}),t}var e;return __extendsFn(d,r),(e=d).VERSION="_1",d.BUFFER_KEY="AI_buffer"+e.VERSION,d.SENT_BUFFER_KEY="AI_sentBuffer"+e.VERSION,d.MAX_BUFFER_SIZE=2e3,d}(BaseSendBuffer),Serializer=function(){function e(l){dynamicProto(e,this,function(e){function c(i,_){var e="__aiCircularRefCheck",s={};if(!i)return _throwInternal(l,1,48,"cannot serialize object because it is null or undefined",{name:_},!0),s;if(i[e])return _throwInternal(l,2,50,"Circular reference detected while serializing object",{name:_},!0),s;if(i.aiDataContract)return i[e]=!0,objForEachKey(i.aiDataContract,function(e,t){var n=isFunction(t)?1&t():1&t,r=isFunction(t)?4&t():4&t,t=2&t,o=i[e]!==undefined,a=isObject(i[e])&&null!==i[e];!n||o||t?r||(n=a?(t?u:c)(i[e],e):i[e])!==undefined&&(s[e]=n):_throwInternal(l,1,24,"Missing required field specification. The field is required but not present on source",{field:e,name:_})}),delete i[e],s;if("measurements"===_)s=n(i,"number",_);else if("properties"===_)s=n(i,"string",_);else if("tags"===_)s=n(i,"string",_);else if(isArray(i))s=u(i,_);else{_throwInternal(l,2,49,"Attempting to serialize an object which does not implement ISerializable",{name:_},!0);try{getJSON()[_DYN_STRINGIFY](i),s=i}catch(t){_throwInternal(l,1,48,t&&isFunction(t[_DYN_TO_STRING])?t[_DYN_TO_STRING]():"Error serializing object",null,!0)}}return s}function u(e,t){if(e)if(isArray(e))for(var n=[],r=0;r<e[_DYN_LENGTH];r++){var o=c(e[r],t+"["+r+"]");n[_DYN_PUSH](o)}else _throwInternal(l,1,54,"This field was specified as an array in the contract but the item is not an array.\r\n",{name:t},!0);return n}function n(e,n,r){var o;return e&&(o={},objForEachKey(e,function(e,t){"string"===n?t===undefined?o[e]="undefined":null===t?o[e]="null":t[_DYN_TO_STRING]?o[e]=t[_DYN_TO_STRING]():o[e]="invalid field: toString() is not defined.":"number"===n?t===undefined?o[e]="undefined":o[e]=null===t?"null":parseFloat(t):(o[e]="invalid field: "+r+" is of unknown type.",_throwInternal(l,1,o[e],null,!0))})),o}e.serialize=function(e){e=c(e,"root");try{return getJSON()[_DYN_STRINGIFY](e)}catch(t){_throwInternal(l,1,48,t&&isFunction(t[_DYN_TO_STRING])?t[_DYN_TO_STRING]():"Error serializing object",null,!0)}}})}return e.__ieDyn=1,e}(),MIN_INPUT_LENGTH=8,HashCodeScoreGenerator=function(){function t(){}return t.prototype.getHashCodeScore=function(e){return this.getHashCode(e)/t.INT_MAX_VALUE*100},t.prototype.getHashCode=function(e){if(""===e)return 0;for(;e[_DYN_LENGTH]<MIN_INPUT_LENGTH;)e=e[_DYN_CONCAT](e);for(var t=5381,n=0;n<e[_DYN_LENGTH];++n)t=(t<<5)+t+e.charCodeAt(n),t&=t;return Math.abs(t)},t.INT_MAX_VALUE=2147483647,t}(),SamplingScoreGenerator=function(){var t=new HashCodeScoreGenerator,n=new ContextTagKeys;this.getSamplingScore=function(e){return e[_DYN_TAGS]&&e[_DYN_TAGS][n.userId]?t.getHashCodeScore(e[_DYN_TAGS][n.userId]):e.ext&&e.ext.user&&e.ext.user.id?t[_DYN_GET_HASH_CODE_SCORE](e.ext.user.id):e[_DYN_TAGS]&&e[_DYN_TAGS][n.operationId]?t.getHashCodeScore(e[_DYN_TAGS][n.operationId]):e.ext&&e.ext.telemetryTrace&&e.ext.telemetryTrace[_DYN_TRACE_ID]?t.getHashCodeScore(e.ext.telemetryTrace[_DYN_TRACE_ID]):100*Math.random()}},Sample=function(){function e(e,t){this.INT_MAX_VALUE=2147483647;t=t||safeGetLogger(null);(100<e||e<0)&&(t.throwInternal(2,58,"Sampling rate is out of range (0..100). Sampling will be disabled, you may be sending too much data which may affect your AI service level.",{samplingRate:e},!0),e=100),this[_DYN_SAMPLE_RATE]=e,this.samplingScoreGenerator=new SamplingScoreGenerator}return e.prototype.isSampledIn=function(e){var t=this[_DYN_SAMPLE_RATE];return null===t||t===undefined||100<=t||e.baseType===Metric[_DYN_DATA_TYPE]||this.samplingScoreGenerator.getSamplingScore(e)<t},e}(),UNDEFINED_VALUE=undefined,EMPTY_STR="",FetchSyncRequestSizeLimitBytes=65e3;function _getResponseText(e){try{return e.responseText}catch(t){}return null}function isOverrideFn(e){return e&&e.sendPOST}var defaultAppInsightsChannelConfig=objDeepFreeze(((_a={endpointUrl:cfgDfValidate(isTruthy,DEFAULT_BREEZE_ENDPOINT+DEFAULT_BREEZE_PATH)})[_DYN_EMIT_LINE_DELIMITED_0]=cfgDfBoolean(),_a.maxBatchInterval=15e3,_a[_DYN_MAX_BATCH_SIZE_IN_BY1]=102400,_a.disableTelemetry=cfgDfBoolean(),_a[_DYN_ENABLE_SESSION_STORA5]=cfgDfBoolean(!0),_a.isRetryDisabled=cfgDfBoolean(),_a[_DYN_IS_BEACON_API_DISABL3]=cfgDfBoolean(!0),_a[_DYN_DISABLE_SEND_BEACON_7]=cfgDfBoolean(!0),_a.disableXhr=cfgDfBoolean(),_a[_DYN_ONUNLOAD_DISABLE_FET6]=cfgDfBoolean(),_a[_DYN_ONUNLOAD_DISABLE_BEA2]=cfgDfBoolean(),_a[_DYN_INSTRUMENTATION_KEY]=UNDEFINED_VALUE,_a.namePrefix=UNDEFINED_VALUE,_a.samplingPercentage=cfgDfValidate(_chkSampling,100),_a[_DYN_CUSTOM_HEADERS]=UNDEFINED_VALUE,_a.convertUndefined=UNDEFINED_VALUE,_a.eventsLimitInMem=1e4,_a[_DYN_BUFFER_OVERRIDE]=!1,_a.httpXHROverride={isVal:isOverrideFn,v:UNDEFINED_VALUE},_a[_DYN_ALWAYS_USE_XHR_OVERR4]=cfgDfBoolean(),_a.transports=UNDEFINED_VALUE,_a.retryCodes=UNDEFINED_VALUE,_a.corsPolicy=UNDEFINED_VALUE,_a.maxRetryCnt={isVal:isNumber,v:10},_a)),CrossOriginResourcePolicyHeader="X-Set-Cross-Origin-Resource-Policy";function _chkSampling(e){return!isNaN(e)&&0<e&&e<=100}(_b={})[Event$1.dataType]=EventEnvelopeCreator,_b[Trace.dataType]=TraceEnvelopeCreator,_b[PageView.dataType]=PageViewEnvelopeCreator,_b[PageViewPerformance.dataType]=PageViewPerformanceEnvelopeCreator,_b[Exception.dataType]=ExceptionEnvelopeCreator,_b[Metric.dataType]=MetricEnvelopeCreator,_b[RemoteDependencyData.dataType]=DependencyEnvelopeCreator;var EnvelopeTypeCreator=_b,Sender=function(e){function se(){var I,O,v,R,P,h,C,L,b,U,F,M,G,w,x,H,j,V,B,$,k,K,z,X,W,q,J,Z,Q,ee,te,ne,re,oe,ae,ie=e.call(this)||this,_e=(ie.priority=1001,ie.identifier=BreezeChannelIdentifier,0);return dynamicProto(se,ie,function(E,r){function f(e,t){var n=_getResponseText(e);!e||n+""!="200"&&""!==n?(n=parseResponse(n))&&n[_DYN_ITEMS_RECEIVED]&&n[_DYN_ITEMS_RECEIVED]>n[_DYN_ITEMS_ACCEPTED]&&!k?E[_DYN__ON_PARTIAL_SUCCESS](t,n):E[_DYN__ON_ERROR](t,formatErrorMessageXdr(e)):(I=0,E[_DYN__ON_SUCCESS](t,0))}function D(e,t,n){4===e.readyState&&g(e.status,t,e.responseURL,n,formatErrorMessageXhr(e),_getResponseText(e)||e.response)}function d(e){try{var t;if(e)return(t=e.oriPayload)&&t[_DYN_LENGTH]?t:null}catch(n){}return null}function s(e,t){return!(V||(e?e.baseData&&!e[_DYN_BASE_TYPE]?(t&&_throwInternal(t,1,70,"Cannot send telemetry without baseData and baseType"),1):(e[_DYN_BASE_TYPE]||(e[_DYN_BASE_TYPE]="EventData"),E[_DYN__SENDER]?E._sample.isSampledIn(e)?(e[SampleRate]=E._sample[_DYN_SAMPLE_RATE],0):(t&&_throwInternal(t,2,33,"Telemetry item was sampled out and not sent",{SampleRate:E._sample[_DYN_SAMPLE_RATE]}),1):(t&&_throwInternal(t,1,28,"Sender was not initialized"),1)):(t&&_throwInternal(t,1,7,"Cannot send empty telemetry"),1)))}function c(e,n){var t=e.iKey||B,r=se.constructEnvelope(e,t,n,$);if(r){var o=!1;if(e[_DYN_TAGS]&&e[_DYN_TAGS][ProcessLegacy]&&(arrForEach(e[_DYN_TAGS][ProcessLegacy],function(e){try{e&&!1===e(r)&&(o=!0,_warnToConsole(n,"Telemetry processor check returns false"))}catch(t){_throwInternal(n,1,64,"One of telemetry initializers failed, telemetry item will not be sent: "+getExceptionName(t),{exception:dumpObj(t)},!0)}}),delete e[_DYN_TAGS][ProcessLegacy]),!o)return r}else _throwInternal(n,1,47,"Unable to create an AppInsights envelope")}function e(e){var t=EMPTY_STR,n=E[_DYN_DIAG_LOG]();try{var r=s(e,n),o=null;(o=r?c(e,n):o)&&(t=P.serialize(o))}catch(a){}return t}function t(e){var t=EMPTY_STR;return e&&e[_DYN_LENGTH]?"["+e.join(",")+"]":t}function n(e){var t=o();return{urlString:F,data:e,headers:t}}function T(e,o,t,n){void 0===n&&(n=!0);var r=function(e,t,n){var r=o;200===e&&r?E._onSuccess(r,r[_DYN_LENGTH]):n&&E[_DYN__ON_ERROR](r,n)},a=S(o),i=e&&e.sendPOST;return i&&a&&(n&&E._buffer[_DYN_MARK_AS_SENT](o),re.preparePayload(function(e){return i(e,r,!t)},ae,a,!t)),null}function S(e){var t,n;return isArray(e)&&0<e[_DYN_LENGTH]?(t=E[_DYN__BUFFER].batchPayloads(e),n=o(),{data:t,urlString:F,headers:n,disableXhrSync:Z,disableFetchKeepAlive:!Q,oriPayload:e}):null}function o(){try{var e=C||{};return isInternalApplicationInsightsEndpoint(F)&&(e[RequestHeaders[6]]=RequestHeaders[7]),e}catch(t){}return null}function p(e){e=e?e[_DYN_LENGTH]:0;E[_DYN__BUFFER].size()+e>G&&(b&&!b.isOnline()||E[_DYN_TRIGGER_SEND](!0,null,10))}function g(e,t,n,r,o,a){var i=null;E._appId||(i=parseResponse(a))&&i.appId&&(E._appId=i.appId),(e<200||300<=e)&&0!==e?301!==e&&307!==e&&308!==e||_(n)?b&&!b.isOnline()?k||(l(t,10),_throwInternal(E[_DYN_DIAG_LOG](),2,40,". Offline - Response Code: ".concat(e,". Offline status: ").concat(!b.isOnline(),". Will retry to send ").concat(t.length," items."))):!k&&Y(e)?(l(t),_throwInternal(E[_DYN_DIAG_LOG](),2,40,". Response code "+e+". Will retry to send "+t[_DYN_LENGTH]+" items.")):E[_DYN__ON_ERROR](t,o):E[_DYN__ON_ERROR](t,o):(_(n),206===e?(i=i||parseResponse(a))&&!k?E[_DYN__ON_PARTIAL_SUCCESS](t,i):E[_DYN__ON_ERROR](t,o):(I=0,E[_DYN__ON_SUCCESS](t,r)))}function _(e){return!(10<=h)&&!isNullOrUndefined(e)&&""!==e&&e!==F&&(F=e,++h,1)}function a(e,t){if(!L)return T(re&&re[_DYN_GET_SENDER_INST]([3],!0),e,t);L(e,!1)}function u(e){try{if(e&&e[_DYN_LENGTH])return isString(e[0])}catch(t){}}function m(e,t){var n=null;if(isArray(e)){for(var r=e[_DYN_LENGTH],o=0;o<e[_DYN_LENGTH];o++)r+=e[o].item[_DYN_LENGTH];return re.getSyncFetchPayload()+r<=FetchSyncRequestSizeLimitBytes?n=2:isBeaconsSupported()?n=3:(n=1,_throwInternal(E[_DYN_DIAG_LOG](),2,40,". Failed to send telemetry with Beacon API, retried with xhrSender.")),T(re&&re[_DYN_GET_SENDER_INST]([n],!0),e,t)}return null}function l(e,t){if(void 0===t&&(t=1),e&&0!==e[_DYN_LENGTH]){var n=E[_DYN__BUFFER];n[_DYN_CLEAR_SENT](e),I++;for(var r=0,o=e;r<o.length;r++){var a=o[r];a.cnt=a.cnt||0,a.cnt++,n[_DYN_ENQUEUE](a)}var e=t,t=(e=I<=1?10:(t=mathFloor((Math.pow(2,I)-1)/2*Math.random()*10)+1,mathMax(mathMin(t*=e,3600),10)),utcNow()+1e3*e);O=t,N()}}function N(){var e;R||v||(e=O?mathMax(0,O-utcNow()):0,e=mathMax(K,e),R=scheduleTimeout(function(){R=null,E[_DYN_TRIGGER_SEND](!0,null,1)},e))}function y(){R&&R.cancel(),O=R=null}function Y(e){return isNullOrUndefined(oe)?401===e||408===e||429===e||500===e||502===e||503===e||504===e:oe[_DYN_LENGTH]&&~oe.indexOf(e)}function A(e,t){var n,r="getNotifyMgr",o=E.core,r=n=o?o[r]?o[r]():o._notificationManager:n;if(r&&r.eventsSendRequest)try{r.eventsSendRequest(e,t)}catch(a){_throwInternal(E[_DYN_DIAG_LOG](),1,74,"send request notification failed: "+getExceptionName(a),{exception:dumpObj(a)})}}function i(){E[_DYN__SENDER]=null,E[_DYN__BUFFER]=null,E._appId=null,E._sample=null,G=_e=h=I=0,W=$=UNDEFINED_VALUE,ne=Q=Z=k=V=w=v=!(C={}),re=te=ee=z=B=j=M=F=U=L=P=R=O=b=null,objDefine(E,"_senderConfig",{g:function(){return objExtend({},defaultAppInsightsChannelConfig)}})}i(),E.pause=function(){y(),v=!0},E.resume=function(){v&&(v=!1,O=null,p(),N())},E.flush=function(e,t,n){if(void 0===e&&(e=!0),!v){y();try{return E[_DYN_TRIGGER_SEND](e,null,n||1)}catch(r){_throwInternal(E[_DYN_DIAG_LOG](),1,22,"flush failed, telemetry will not be collected: "+getExceptionName(r),{exception:dumpObj(r)})}}},E.onunloadFlush=function(){if(!v)if(w||J)try{return E[_DYN_TRIGGER_SEND](!0,a,2)}catch(e){_throwInternal(E[_DYN_DIAG_LOG](),1,20,"failed to flush with beacon sender on page unload, telemetry will not be collected: "+getExceptionName(e),{exception:dumpObj(e)})}else E.flush(!1)},E.addHeader=function(e,t){C[e]=t},E[_DYN_INITIALIZE]=function(e,u,t,n){E.isInitialized()&&_throwInternal(E[_DYN_DIAG_LOG](),1,28,"Sender is already initialized"),r[_DYN_INITIALIZE](e,u,t,n);var l=E.identifier,N=(P=new Serializer(u.logger),I=0,O=null,E[_DYN__SENDER]=null,h=0,E[_DYN_DIAG_LOG]());U=mergeEvtNamespace(createUniqueNamespace("Sender"),u.evtNamespace&&u.evtNamespace()),b=createOfflineListener(U),E._addHook(onConfigChange(e,function(e){e=e.cfg;e.storagePrefix&&utlSetStoragePrefix(e.storagePrefix);var t=createProcessTelemetryContext(null,e,u).getExtCfg(l,defaultAppInsightsChannelConfig),n=t[_DYN_ENDPOINT_URL],n=(F&&n===F&&(r=e[_DYN_ENDPOINT_URL])&&r!==n&&(t[_DYN_ENDPOINT_URL]=r),getInst("CompressionStream")),r=(ae=isFeatureEnabled("zipPayload",e,!1),isFunction(n)||(ae=!1),t.corsPolicy),n=(r?"same-origin"!==r&&"same-site"!==r&&"cross-origin"!==r||ie.addHeader(CrossOriginResourcePolicyHeader,r):delete C[CrossOriginResourcePolicyHeader],isPromiseLike(t[_DYN_INSTRUMENTATION_KEY])&&(t[_DYN_INSTRUMENTATION_KEY]=e[_DYN_INSTRUMENTATION_KEY]),objDefine(E,"_senderConfig",{g:function(){return t}}),M!==t[_DYN_ENDPOINT_URL]&&(F=M=t[_DYN_ENDPOINT_URL]),u.activeStatus()===ActiveStatus.PENDING?E.pause():u.activeStatus()===ActiveStatus.ACTIVE&&E.resume(),j&&j!==t[_DYN_CUSTOM_HEADERS]&&arrForEach(j,function(e){delete C[e.header]}),G=t[_DYN_MAX_BATCH_SIZE_IN_BY1],w=(!1===t[_DYN_ONUNLOAD_DISABLE_BEA2]||!1===t[_DYN_IS_BEACON_API_DISABL3])&&isBeaconsSupported(),x=!1===t[_DYN_ONUNLOAD_DISABLE_BEA2]&&isBeaconsSupported(),H=!1===t[_DYN_IS_BEACON_API_DISABL3]&&isBeaconsSupported(),J=t[_DYN_ALWAYS_USE_XHR_OVERR4],Z=!!t.disableXhr,oe=t.retryCodes,t[_DYN_BUFFER_OVERRIDE]),r=!!t[_DYN_ENABLE_SESSION_STORA5]&&(!!n||utlCanUseSessionStorage()),o=t.namePrefix,a=r!==z||r&&W!==o||r&&X!==n;if(E[_DYN__BUFFER]){if(a)try{E[_DYN__BUFFER]=E[_DYN__BUFFER].createNew(N,t,r)}catch(c){_throwInternal(E[_DYN_DIAG_LOG](),1,12,"failed to transfer telemetry to different buffer storage, telemetry will be lost: "+getExceptionName(c),{exception:dumpObj(c)})}p()}else E[_DYN__BUFFER]=new(r?SessionStorageSendBuffer:ArraySendBuffer)(N,t);W=o,z=r,X=n,Q=!t[_DYN_ONUNLOAD_DISABLE_FET6]&&isFetchSupported(!0),ne=!!t[_DYN_DISABLE_SEND_BEACON_7],E._sample=new Sample(t.samplingPercentage,N),isPromiseLike(B=t[_DYN_INSTRUMENTATION_KEY])||(a=B,!isNullOrUndefined(o=e.disableInstrumentationKeyValidation)&&o||/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/.test(a))||_throwInternal(N,1,100,"Invalid Instrumentation key "+B),j=t[_DYN_CUSTOM_HEADERS],isString(F)&&!isInternalApplicationInsightsEndpoint(F)&&j&&0<j[_DYN_LENGTH]?arrForEach(j,function(e){ie.addHeader(e.header,e.value)}):j=null,q=t.enableSendPromise;var r=function(){try{return{enableSendPromise:q,isOneDs:!1,disableCredentials:!1,disableXhr:Z,disableBeacon:!H,disableBeaconSync:!x,senderOnCompleteCallBack:{xdrOnComplete:function(e,t,n){n=d(n);if(n)return f(e,n)},fetchOnComplete:function(e,t,n,r){r=d(r);if(r)return g(e.status,r,e.url,r[_DYN_LENGTH],e.statusText,n||"")},xhrOnComplete:function(e,t,n){n=d(n);if(n)return D(e,n,n[_DYN_LENGTH])},beaconOnRetry:function(e,t,n){var r=t,o=n,a=e&&e.oriPayload;if(ne)te&&te(a,!0),_throwInternal(E[_DYN_DIAG_LOG](),2,40,". Failed to send telemetry with Beacon API, retried with normal sender.");else{for(var i=[],_=0;_<a[_DYN_LENGTH];_++){var s=a[_],c=[s];o(S(c),r)?E._onSuccess(c,c[_DYN_LENGTH]):i[_DYN_PUSH](s)}0<i[_DYN_LENGTH]&&(te&&te(i,!0),_throwInternal(E[_DYN_DIAG_LOG](),2,40,". Failed to send telemetry with Beacon API, retried with normal sender."))}}}}}catch(e){}return null}(),n=(re?re.SetConfig(r):(re=new SenderPostManager)[_DYN_INITIALIZE](r,N),t.httpXHROverride),i=null,_=null,e=prependTransports([3,1,2],t.transports),i=re&&re[_DYN_GET_SENDER_INST](e,!1),s=re&&re.getFallbackInst(),o=(ee=function(e,t){return T(s,e,t)},te=function(e,t){return T(s,e,t,!1)},i=J?n:i||n||s,E[_DYN__SENDER]=function(e,t){return T(i,e,t)},Q&&(L=m),prependTransports([3,1],t.unloadTransports));Q||(o=o.filter(function(e){return 2!==e})),_=re&&re[_DYN_GET_SENDER_INST](o,!0),_=!J&&_||n,L=(L=(J||t.unloadTransports||!L)&&_?function(e,t){return T(_,e,t)}:L)||ee,V=t.disableTelemetry,$=t.convertUndefined||UNDEFINED_VALUE,k=t.isRetryDisabled,K=t.maxBatchInterval}))},E.processTelemetry=function(e,t){var n=(t=E._getTelCtx(t))[_DYN_DIAG_LOG]();try{if(!s(e,n))return;var r=c(e,n);if(!r)return;var o=P.serialize(r),a=E[_DYN__BUFFER],i=(p(o),{item:o,cnt:0});a[_DYN_ENQUEUE](i),N()}catch(_){_throwInternal(n,2,12,"Failed adding telemetry to the sender's buffer, some telemetry will be lost: "+getExceptionName(_),{exception:dumpObj(_)})}E.processNext(e,t)},E.isCompletelyIdle=function(){return!v&&0===_e&&0===E._buffer[_DYN_COUNT]()},E.getOfflineListener=function(){return b},E._xhrReadyStateChange=function(e,t,n){if(!u(t))return D(e,t,n)},E[_DYN_TRIGGER_SEND]=function(e,t,n){var r;if(void 0===e&&(e=!0),!v)try{var o,a=E[_DYN__BUFFER];V?a[_DYN_CLEAR]():0<a[_DYN_COUNT]()&&(o=a.getItems(),A(n||0,e),r=t?t.call(E,o,e):E[_DYN__SENDER](o,e)),y()}catch(i){a=getIEVersion();(!a||9<a)&&_throwInternal(E[_DYN_DIAG_LOG](),1,40,"Telemetry transmission failed, some telemetry will be lost: "+getExceptionName(i),{exception:dumpObj(i)})}return r},E.getOfflineSupport=function(){return{getUrl:function(){return F},createPayload:n,serialize:e,batch:t,shouldProcess:function(e){return!!s(e)}}},E._doTeardown=function(e,t){E.onunloadFlush(),runTargetUnload(b,!1),i()},E[_DYN__ON_ERROR]=function(e,t,n){if(!u(e))return e=e,t=t,_throwInternal(E[_DYN_DIAG_LOG](),2,26,"Failed to send telemetry.",{message:t}),void(E._buffer&&E._buffer[_DYN_CLEAR_SENT](e))},E[_DYN__ON_PARTIAL_SUCCESS]=function(e,t){if(!u(e)){for(var n=e,e=t,r=[],o=[],a=0,i=e.errors.reverse();a<i.length;a++){var _=i[a],s=n.splice(_.index,1)[0];(Y(_.statusCode)?o:r)[_DYN_PUSH](s)}0<n[_DYN_LENGTH]&&E[_DYN__ON_SUCCESS](n,e[_DYN_ITEMS_ACCEPTED]),0<r[_DYN_LENGTH]&&E[_DYN__ON_ERROR](r,formatErrorMessageXhr(null,["partial success",e[_DYN_ITEMS_ACCEPTED],"of",e.itemsReceived].join(" "))),0<o[_DYN_LENGTH]&&(l(o),_throwInternal(E[_DYN_DIAG_LOG](),2,40,"Partial success. Delivered: "+n[_DYN_LENGTH]+", Failed: "+r[_DYN_LENGTH]+". Will retry to send "+o[_DYN_LENGTH]+" our of "+e[_DYN_ITEMS_RECEIVED]+" items"))}},E[_DYN__ON_SUCCESS]=function(e,t){u(e)||E._buffer&&E._buffer[_DYN_CLEAR_SENT](e)},E._xdrOnLoad=function(e,t){if(!u(t))return f(e,t)}}),ie}return __extendsFn(se,e),se.constructEnvelope=function(e,t,n,r){e=t===e.iKey||isNullOrUndefined(t)?e:__assignFn(__assignFn({},e),{iKey:t});return(EnvelopeTypeCreator[e.baseType]||EventEnvelopeCreator)(n,e,r)},se}(BaseTelemetryPlugin);exports.Sender=Sender;
//# sourceMappingURL=applicationinsights-channel-js.3.cjs.min.js.map
